
/**
 * 
 */
class dosint_dig {
    constructor ($nid) {
        this.nid = $nid;
        this.nObj = MEMG.getNeuronByNid($nid);
    }

    getAll=async()=> {
        await this.getIns();
        await this.getOuts();
    }

    getIns=async()=> {
        return await ANNE.API.getIns(this.nid, []);
    }

    getOuts=async()=>  {
        return await ANNE.API.getOuts(this.nid, []);
    }
}


/**
 * 
 */
class dosint_dig_date extends dosint_dig {
    constructor($datenid) {
        super($datenid);
        this.adate = null;
        this.onThisDayMap = null;
    }    

    setDate=function() {
        if (this.nObj==null) {
            console.log("must have nObj here.");
            return;
        }
        if (this.nObj.is(ANNE.MEM.date_gregorian)==false) {
            console.log("must be date to process as date.");
        }
        this.nObj.processAsDate();
    }


    onThisDate=async()=>{

    }


    /**
     * Calculate all dates on this date part, and then do an onThisDate.
     */
    onThisDatePart=async()=> {
        var target_nid = this.nObj.nid;

        if (this.nObj.bes[0]==ANNE.MEM.daymonth.temp_nid) {
            target_nid = this.nObj.nid;
        }
        else if (this.nObj.bes[0]==ANNE.MEM.date_gregorian.temp_nid) {
            if (this.adate==null) this.setDate();
            target_nid = this.adate.daymonthNOBJ.nid;
        }

        if (target_nid==null) {
            console.log("no date part.");
            return;
        }

        //we will get a list of date neuron that match this date part.
        //so we will be left with,  june 1, 2022,     june 1, 2018,   june, 1843   etc.
        //snags all froms with matching reln (daymonth) + to (the target)
        await ANNE.API.getAllFromNeuronRelonsGeneric(MEM.daymonth.nid, target_nid);

        var datePARTNOBJ = MEMG.getNeuronByNid(target_nid); //will be same as nObj if this IS a date part.
        
        //will return all nObjs that are connected to this date part.
        //here we want all things pointing to our desired date part with a daymonth reln in their relon.
        var dateArrMap = await MEMG.getFromArrayMap(datePARTNOBJ.ins, ANNE.MEM.daymonth.temp_nid);
        var nids = dateArrMap.getKeys();
        var dateNOBJS = dateArrMap.arr;

        //we made sure to get these dateNOBJS names.
        //now we want to get all the things they are used in.

        //We need to get all the things that connect into our target nids...
        //but we need multiple relns and multiple targets..
        
        await ANNE.API.getAllInsToTheseNids(nids);

        //now take the dateNOBJS, and sort by them.
        this.onThisDayMap = new arraymap();

        for (var d=0; d < dateNOBJS.length; d++) {
            
            var dateN = dateNOBJS[d];
            if (dateN.is(MEM.gregorian_date)==true) dateN.processAsDate();

            console.log("date:"+dateN.text);

            for (var i=0; i < dateNOBJS[d].ins.length; i++) {
                var somethingN = ANNE.MEMG.getNeuronByNid(dateNOBJS[d].ins[i].from_nid);
                this.onThisDayMap.addUnique(somethingN, somethingN.from_nid);
                console.log(somethingN.text);
            }
        }
    }

}


/**
 * 
 */
class dosint_dig_date_compare {
    constructor($nid1, $nid2) {
        this.dig1 = new dosint_dig_date($nid1);
        this.dig2 = new dosint_dig_date($nid2);
    }

    load = async()=>{
        this.dig1.getAll();
        this.dig1.setDate();
        this.dig2.getAll();
        this.dig2.setDate();
    }
}