var A2A = {};
A2A.sessionCache = new Object();
A2A.savings = 0;

//local cache is only for very small files as this is RAM.
//it saves us a trip to the annode on any given session.

//LET'S SET THIS WITH A CONFIG BYTE SLIDER IN THE GUI.
A2A.TOO_BIG = 512000;       

A2A.nids_tried = [];


//TODO:
//we should only be storing in the cache the files we have to get from the net.
//don't bother caching files stored on local annode...
//as they are already local, on the annode (or a local folder)
A2A.addToCache=function($afile, $bFORCE=false) {
    if (!$afile) return;
    if ($bFORCE==false && $afile.fileNOBJ!=null && $afile.fileNOBJ.ghost==false) {
        if ($afile.size>A2A.TOO_BIG) {
            console.log($afile.size+" this file is too big to cache in js.. just repull it from annode.");
        }
    }

    if ($afile.fileNOBJ!=null) {
        if (A2A.sessionCache[$afile.fileNOBJ.nid]==undefined) {
            A2A.sessionCache[$afile.fileNOBJ.nid] = $afile;
        }
    }
    else {
        var hash = md5($afile.url);
        if (A2A.sessionCache[hash]==undefined) {
            A2A.sessionCache[hash] = $afile;
        }
    }
    return;
}


/**
 * 
 * @param {*} $url 
 * @returns 
 */
A2A.loadFileFromURL=async($url)=> {
    var hash = md5($url);
    if (A2A.sessionCache[hash]!=undefined) return A2A.sessionCache[hash];
    var afile = new anne_file();
    afile.setFromNeuron($nObj);
    if (afile.size>A2A.TOO_BIG) return;
    A2A.sessionCache[hash] = animg;
    return animg;
}


A2A.getFileByUrl=function($url) {
    var hash = md5($url);
    if (A2A.sessionCache[hash]!=undefined) {
        A2A.savings+=1;
        return A2A.sessionCache[hash];
    }
    return null;
}


A2A.getOrMakeFilebyUrl=async($url, $relon=null)=> {
    var afile = A2A.getFileByUrl($url);
    if (afile!=null) return afile;
    afile = await IMAGES.getImgMetaFromUrl($url, $relon);   //added to cache in here..
    return afile;
}


/**
 * 
 * @param {*} $nid 
 * @returns {anne_file} 
 */
A2A.getFileByNid=function($nid) {
    if (A2A.sessionCache[$nid]!=undefined) {
        A2A.savings+=1;
        return A2A.sessionCache[$nid];
    }
    return null;
}

/**
 * 
 * @param {string} $url 
 * @param {*} $nid 
 * @returns {anne_file}
 */
A2A.getFileByUrlOrNid=function($url, $nid) {
    var afile = A2A.getFileByUrl($url);
    if (afile!=null) return afile;
    return A2A.getFileByNid($nid);
}


/**
 * 
 * @param {*} $nObj 
 * @returns {anne_file}
 */
A2A.loadFileFromNid=async($nObj)=>{ 
    if (A2A.sessionCache[$nObj.nid]!=undefined) return A2A.sessionCache[$nObj.nid];
    var afile = new anne_file();
    afile.setFromNeuron($nObj);
    if (afile.size>A2A.TOO_BIG) return;
    A2A.sessionCache[$nObj.nid] = afile;
    return afile;
}
