
var ANNDLE = {};
ANNDLE.index = [];

/**
 * Add an anndle ot the quick index.
 * This is done from the mem processor whenever an ANNDLE is seen.
 * @param {*} $anndleNOBJ 
 */
ANNDLE.addQuick=function($anndleNOBJ) {
    var lower = $anndleNOBJ.text.toLowerCase();
    if (ANNDLE.index[lower]==undefined) ANNDLE.index[lower]=$anndleNOBJ;
}

/**
 * Ajax style lookups of partial strings in ANNDLEs.
 * @param {*} $txt 
 * @returns 
 */
ANNDLE.lookup=function($txt) {
    var matches = [];
    var lower = $txt.toLowerCase();
    var keys = Object.keys(ANNDLE.index);
    for (var k=0; k < keys.length; k++) {
        if (keys[k].indexOf(lower)!=-1) {
            matches.push ( ANNDLE.index[ keys[k]] );
        }
    }
    return matches;
}