/**
 * anndles
 * 
 * dont do feeback on anndles as when they change hands then feelz are no longer relevant for that anndle.
 * we still have the data to discern what was what and when but meh.
 * Keep em off, for now.
 */
 class dossier_anndle extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_anndle", TALK.bgredbig);
        this._mode = "viewer";
        this._anndleObj = null; //holder of anndle goodies from annode (data etc)
        this.bSELLBACK = false;
        this.bISANNESPONSORED = false;  //anne has made this and bought it back and it is now free to sponsor again.
    }

    initASYNC = async()=>{
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);
        //await this.getBalance(); 

        ANNE.A.hide("thumbs_widget_"+this.ID);

        var el_logo = ANNE.A.ezSpan(this.el_doss_name,"","ai-anndle-white");
        this.el_doss_name.append(el_logo);
        
        if (this.nObj.sponsored_by==USER._userNObj.nid || this.nObj.ghost==true) {
            this._mode = "manager";
        }
        else {
            this._mode="viewer";
        }
        console.log("%c ANNDLE MODE:%c"+this._mode, ANNE.TALK.bgblack, ANNE.TALK.bgred);

        if (this._mode=="manager") await this.doAnndleParams();

        if (this._mode=="manager" && USER._userLS.aauth.ANNDLE_active==true) {
            var el_subanndle = ANNE.A.ezElPrepend(this.el_actions, "div", "simple-col fba");
            ANNE.A.ezButton(el_subanndle, "", "make a subanndle", "anne-tiny-btn btn-purple-sq btn-maxH", e=>this.makeSubAnndle(e));
        }

        await this.setupAnndleMetrics();

        this.anndle_lvl = 0;

        //make the anndle parent heirachy line displayed out.
        var rel_anndle_lvl = MEMG.getBeRelon(this.all_relons, MEM.anndle_lvl.temp_nid);
        if (rel_anndle_lvl==null) {
            if (this.ghost==true) {
                console.warn("malformed anndle.  Must have a level.  Presuming lvl 1");
                this.anndle_lvl = 1;
            }
        }
        else this.anndle_lvl = parseInt(rel_anndle_lvl.to_s);

        if (this.anndle_lvl==0) {
            var el1 = ANNE.A.ezEl(this.el_content, "div", "pad4 text-center bg-green", "This is a top level-0 ANNDLE");
            ANNE.A.moveElAfter(el1, "bebox_name_"+this.ID);
        }   
        else  {
            var el1 = ANNE.A.ezEl(this.el_content, "div", "pad4 text-center bg-green", "This is a level-"+this.anndle_lvl+" ANNDLE");
            ANNE.A.moveElAfter(el1, "bebox_name_"+this.ID);
            this.genAnndlePath(this.el_content);
        }

        await this.doAllHas(this.el_bes_content, "section-title-center");    //generic.
       
        //display subanndles.
        this.doSubanndleDisplay();

        //this.doAssociate(); //TYPE_BRAIN only assocs.
        //this.doBRAINSection(this.el_content);

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }


    /**
     * 
     */
    setupAnndleMetrics = async()=>{
        if(this.nObj.ghost==true) return;

        this.bISANNESPONSORED=false;
        if (ANNE.isANNE(this.nObj.sponsored_by)==true) this.bISANNESPONSORED=true;

        //no further display for subanndles.
        if (this.nObj.bes[0]!=MEM.anndle.temp_nid) return;
        if (this.nObj.origin!=undefined && this.nObj.origin!=ORIGIN_GLOBAL) return;

        this._anndleObj = await ANNE.API.getAnndlePricing(this.nObj.text);

        this.doManualVal(this.el_bes_content, "anndle cycle", this._anndleObj.anndle_meta_cycle);
        this.doManualVal(this.el_bes_content, "lunar cycles remaining", this._anndleObj.lunar_cycles_remaining+"+");
        
        //only show buyback if ANNE doesn't already have it.
        if (this.bISANNESPONSORED==false) {
            this.doManualVal(this.el_bes_content, "ANNE buyback offer", GUI_STUFF.doAnniesToANNE_HTML(this._anndleObj.buyback_offer_annies), "tal50", "tal50", "");
        }

        var el_holder = null;

        if (this._mode=="manager") {

            //pending sellf from owner back to ANNE from OWNER
            var rel_pending_sell = MEMG.getSysMsgRelonTo(USER._userNObj.outs, MEM.anndle_sellback.temp_nid, this.nObj.nid);
            if (rel_pending_sell!=null) {
                ANNE.A.ezEl(this.el_bes_content, "span", "tiny-text", "Pending sellback to anne processing.");
            }
            else {
                var bPENDINGRENEWAL=false;
                for (var rr=0; rr < this.nObj.outs.length; rr++) {
                    var rr_rel =  this.nObj.outs[rr];
                    if (rr_rel.type!=TYPE_SYS_MSG) continue;
                    if (rr_rel.r!=MEM.anndle_renew.temp_nid) continue;
                    if (rr_rel.time!=0) continue;
                    bPENDINGRENEWAL=true;
                }
                if (bPENDINGRENEWAL==false) {
                    if (this._anndleObj.buyback_offer_annies!=0) {
                        var msg = "Sellback the remaining cycles of your Anndle to ANNE."                 
                        msg="<BR>ANNE's offer:" + GUI_STUFF.doAnniesToANNE_HTML(this._anndleObj.buyback_offer_annies);
                        var col=ANNE.A.ezEl(this.el_actions, "div", "ar");
                    
                        //TODO: block this until the anndle is confirmed, it makes very little sense otherwise..
                        ANNE.A.btnToLaunchConfirm(col, "anne-tiny-btn btn-yellow-sq btn-maxH", "Sellback Anndle", msg, 
                                async($obj)=>{
                                    console.log($obj);
                                    if(this.bSELLBACK==true) return;
                                    this.bSELLBACK=true;
                                    var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_sellback.nid, TO_TYPE_ANNE, this.nObj.nid);
                                    //reference the freeze, we can't mine this until the neuron is froze!
                                    await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_SELLBACK);   
                                    ANNE.playSound("success");
                                    return await SENDQ.___sendQueue();
                                },
                                async($e)=>{
                                    $e.stopPropagation();
                                    $e.preventDefault();
                                },
                                null);                
                                                    
                    }

                    if (this._anndleObj.renew_now_annies_price>0) {
                        //this.doManualVal(this.el_bes_content, "renewal (+13 lunar cycles)", this._anndleObj.renew_now_annies_price);
                        this.doManualAnnies(this.el_bes_content, "renewal", this._anndleObj.renew_now_annies_price, "extend your anndle for 13 additional lunar cycles");
                        var msg = "Your ANNDLE is going to expire.  Renew now for the next Anndle period to keep this Anndle."                 
                        msg="<BR>Renew cost:" + GUI_STUFF.doAnniesToANNE_HTML(this._anndleObj.renew_now_annies_price);
                        var btnrow = ANNE.A.ezEl(this.el_bes_content, "row", "simple-row", "");
                        var btncol = ANNE.A.ezEl(btnrow, "col", "simple-col ar");
                        var btnrenew = ANNE.A.ezButton(btncol, "", "renew anndle", "anne-tiny-btn btn-green-sq btn-maxH mr4", 
                            async($e)=>{
                                ANNE.A.hide(btnrenew);
                                var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_renew.nid, TO_TYPE_ANNE, this.nObj.nid, this._anndleObj.renew_now_annies_price);
                                await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_RENEW);   
                                ANNE.playSound("success");
                                return await SENDQ.___sendQueue();
                            });
                    }    
                }
                else {
                    ANNE.A.ezEl(this.el_bes_content, "span", "tiny-text", "Pending renewal to add more lunar cycles processing.");
                }
            }
        }

        //make a bigger offer for an ANNDLE.
        else {
            var rel_pending_sell = MEMG.getSysMsgRelon_HIGHEST(this.nObj.outs, MEM.anndle_sellback.temp_nid);
            if (rel_pending_sell!=null) {
                ANNE.A.ezEl(this.el_bes_content, "span", "tiny-text", "Pending sellback from previous sponsor to anne processing.");
            }
            else {
                var minOffer = Math.floor(this._anndleObj.buyback_offer_annies * 1.1); //10% higher than ANNE's offer.
                if (USER._userNObj.balanceObj.annies<minOffer) {
                    //do a mini note footer
                    ANNE.A.ezEl(this.el_bes_content, "span", "tiny-text", "You do not have enough annies to meet the minimum buyside offer requirement.");
                }
                else {   
                    el_holder = ANNE.A.ezAnnecoin_entry(this.el_bes_content, async($annies)=>{
                        ANNE.A.hide(el_holder);
                        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_offer.nid, TO_TYPE_ANNE, this.nObj.nid, $annies);
                        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER);   
                        ANNE.playSound("success");
                        return await SENDQ.___sendQueue();
    
                    }, "make buyout offer", "buyout offer", null, "buyside_offer");
        
                    //min offer must be 10% highre than the algo ANNE offer.
                    //max offer cannot be more than the user paid.  This is not a sell-market.
                    var btnm = ANNE.A.setAttribute("btn_main_buyside_offer", "i_placeholder", "min annies "+minOffer);
                    btnm.setAttribute("i_min_val", minOffer);
                    var maxval = Math.min(USER._userNObj.balanceObj.annies, this._anndleObj.max_val);
                    btnm.setAttribute("i_max_val", maxval);
                }
            }

        }

        //OUTSTANDING OFFERS TO BUY THIS ANNDLE.
        var offers = MEMG.getSysMsgRelons(this.nObj.ins, MEM.anndle_offer.temp_nid);
        var real_offers = [];
        if (offers.length) {
            for (var r=0; r < offers.length; r++) {
                var rel_offer = offers[r];
                if (rel_offer.ghost==true) continue;
                real_offers.push(rel_offer);
            }
        }
        if (real_offers.length) {
            //if we have offers let's show the balance of this.
            var bal_el = await this.getBalance();
            
            ANNE.A.tooltip(bal_el, "This balance is controlled by L1 protocol and used as proof of funds for potentials deals.", "");

            ANNE.A.ezEl(this.el_content, "div", "simple-row bg-yellow pad4", "** Buy Offers **");
            var offers_div = ANNE.A.ezEl(this.el_content, "div", "simple-row pad8", "");
            for (var r=0; r < real_offers.length; r++) {
                var rel_offer = real_offers[r];
                if (rel_offer.ghost==true) continue;
                var rel_to_show = rel_offer;
                var annies = rel_offer.annies;
                var spanblock = ANNE.A.ezEl(offers_div, "span", "spanblock", "");
                ANNE.A.ezAnniesToAnneDisplay(spanblock, annies);
        
                var statusText = "";
                if (ANNE.UTILS.isset(rel_offer.sys_ref_txid)==true) {
                    rel_offer.revokable=false;
                    var sys_ref_rel = MEMG.lookupByTXID(rel_offer.sys_ref_txid);
                    if (sys_ref_rel==null) {
                        //do a status click (to get status and show it);
                        statusText = "(to do, lookup clicker)";
                    }
                    else if (sys_ref_rel.time==0) {
                        var statusNOBJ = MEMG.getNeuronByTempNid(sys_ref_rel.r);
                        statusText = statusNOBJ.text+", pending mining";
                    }
                    else {
                        var statusNOBJ = MEMG.getNeuronByTempNid(sys_ref_rel.r);
                        statusText = statusNOBJ.text;
                    }
                }
                
                //a pending status change... OR no response yet..
                else {
                    statusText = "pending";

                    if (rel_offer.from_nid==USER._userNObj.nid) {
                        if (el_holder!=null) ANNE.A.hide(el_holder);
                        rel_offer.revokable=true;
                    }

                    for (var rr=0; rr < this.nObj.outs.length; rr++) {
                        var rr_rel = this.nObj.outs[rr];
                        if (rr_rel.type!=TYPE_SYS_MSG) continue;
                        if (rr_rel.to_s!=rel_offer.txid) continue;
                        var relnNOBJ = MEMG.getNeuronByTempNid(rr_rel.r);
                        if (relnNOBJ.temp_nid==MEM.anndle_accept_offer.temp_nid) {
                            statusText = "accepted, pending mining";
                            rel_offer.revokable=false;
                            if (rr_rel.time>0) statusText = "accepted";
                        }
                        else if (relnNOBJ.temp_nid==MEM.anndle_reject_offer.temp_nid) {
                            statusText = "reject, pending mining";
                            rel_offer.revokable=false;
                            if (rr_rel.time>0) statusText = "rejected";
                        }
                        else if (relnNOBJ.temp_nid==MEM.anndle_revoke_offer.temp_nid) {
                            statusText = "revoke, pending mining";
                            rel_offer.revokable=false;
                            if (rr_rel.time>0) statusText = "revoked";
                        }
                        else if (relnNOBJ.temp_nid==MEM.anndle_offer_nullified.temp_nid) {
                            statusText = "nullification, pending mining";
                            rel_offer.revokable=false;
                            if (rr_rel.time>0) statusText = "nullified";
                        }
                        rel_to_show = rr_rel;
                    }
                }

                EXT_BTNS.makeRelonViewLink_SMART(spanblock, rel_to_show, false, 8, true, "", statusText);
  
                //do accept reject btn
                if (this._mode=="manager") {
                    if ( statusText=="pending") {
                        var btn = ANNE.A.ezButton(spanblock, "", "accept offer", "anne-tiny-btn btn-green-sq btn-maxH mr4", async($e)=>{
                            var offer_txid = $e.target.getAttribute("txid");
                            ANNE.A.hide(btn); //7777288463269446287
                            var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_accept_offer.nid, TO_TYPE_TXID, offer_txid);
                            await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_ACCEPT_OFFER);   
                            ANNE.playSound("success");
                            return await SENDQ.___sendQueue();
                        });
                        btn.setAttribute("txid", rel_offer.txid);
                        var btn2 = ANNE.A.ezButton(spanblock, "", "reject offer", "anne-tiny-btn btn-red-sq btn-maxH mr4", async($e)=>{
                            var offer_txid = $e.target.getAttribute("txid");
                            ANNE.A.hide(btn2);
                            var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_reject_offer.nid, TO_TYPE_TXID, offer_txid);
                            await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_REJECT_OFFER);   
                            ANNE.playSound("success");
                            return await SENDQ.___sendQueue();
                        });
                        btn2.setAttribute("txid", rel_offer.txid);
                    }
                }
                else {

                    //submitter of deal can still revoke the deal.
                    if (rel_offer.from_nid==USER._userNObj.nid && rel_offer.revokable==true) {
                        var btnRevoke = ANNE.A.ezButton(spanblock, "", "revoke offer", "anne-tiny-btn btn-red-sq btn-maxH mr4", async($e)=>{
                            var offer_txid = $e.target.getAttribute("txid");
                            ANNE.A.hide(btn2);
                            var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.anndle_revoke_offer.nid, TO_TYPE_TXID, offer_txid);
                            await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ANNDLE_REVOKE_OFFER);   
                            ANNE.playSound("success");
                            return await SENDQ.___sendQueue();
                        });
                        btnRevoke.setAttribute("txid", rel_offer.txid);
                    }
                }
            }
        }
    }


    /**
     * 
     * @param {*} $outs 
     */
    doSubanndleDisplay=function(){
        var suabanndles = ANNE.A.ezEl(this.el_content, "div", "section-title", "subanndles");
        var rel_subanndles = MEMG.getHasRelons(this.all_relons, MEM.subanndle.temp_nid);
        if (rel_subanndles.length==0) {
            var div = ANNE.A.ezEl(this.el_content, "div", "simple-row bg-dark", "no known subanndles");
        }
        for (var r=0; r < rel_subanndles.length; r++) {
            var rel = rel_subanndles[r];
            var div = ANNE.A.ezEl(this.el_content, "div", "simple-row bg-dark")
            EXT_BTNS.makeNeuronLink_colorSquares(div, rel.to_s);
        }
    }


    /**
     * 
     * @param {*} $el 
     */
    genAnndlePath = function($el) {
        var path = [];
        var el_path = ANNE.A.ezEl(this.el_content, "div", "simple-row bg-dark");
        var nextNOBJ = this.nObj;
        var path_nids=[];
        for (var lvl = this.anndle_lvl;  lvl >=0; lvl--) {
            path.push(nextNOBJ.text);
            path_nids.push(nextNOBJ.nid);
            var rel_subanndle_of = MEMG.getBeRelon(nextNOBJ.outs, MEM.subanndle_of.temp_nid);
            if (rel_subanndle_of!=null) {
                nextNOBJ = MEMG.getNeuronByNid(rel_subanndle_of.to_s);
            }
        }
        
        path_nids.reverse();

        for (var p=0; p < path_nids.length; p++) {
            EXT_BTNS.makeNeuronLink_colorSquares(el_path, path_nids[p]);
        }

        //var path_dir = ANNE.A.ezEl(this.el_content, "div", "simple-row", path.join("."));
        //var path_domain = ANNE.A.ezEl(this.el_content, "div", "simple-row", path.reverse().join("/"));

    }



    /**
     * 
     * @param {*} $e 
     */
    makeSubAnndle=async($e)=>{
        var paramsObj = new page_params(null, null, null);
        var misc = {parent_nid:this.nObj.nid};
        paramsObj.misc = misc;
        PAGES.openPage("maker", paramsObj, "anndle", "", misc);
    }


    /**
     * 
     */
    doAnndleParams=async()=>{
        if (this._mode!="manager") return;
        
        this.el_btns=ANNE.A.ezEl(this.el_content, "div", "btns-area"); //only makers will use this.

        this.rel_has_rt_anneid = MEMG.getHasRelon(this.all_relons, MEM.resolves_to_anneid.temp_nid);
        if (this.rel_has_rt_anneid==null) {    
            var rel_param_rt_anneid = MEMG.getParamRelon(this.all_relons, MEM.resolves_to_anneid.temp_nid);
            var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_ANNDLE_EDIT, rel_param_rt_anneid, "set the resolution ANNEID", true);
            btn.setAttribute("prompt", "Set the ANNE neuron this ANNDLE points to.");
        }

        this.rel_has_rt_uri = MEMG.getHasRelon(this.all_relons, MEM.resovles_to_uri.temp_nid);
        if (this.rel_has_rt_uri==null) {    
            var rel_param_rt_uri = MEMG.getParamRelon(this.all_relons, MEM.resovles_to_uri.temp_nid);
            var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_ANNDLE_EDIT, rel_param_rt_uri, "set the resolution URI", true);
            btn.setAttribute("prompt", "Set the external URI this ANNDLE points to.");
        }

        this.rel_has_rt_ipv4 = MEMG.getHasRelon(this.all_relons, MEM.resolves_to_ipv4.temp_nid);
        if (this.rel_has_rt_ipv4==null) {    
            var rel_param_rt_ipv4 = MEMG.getParamRelon(this.all_relons, MEM.resolves_to_ipv4.temp_nid);
            var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_ANNDLE_EDIT, rel_param_rt_ipv4, "set the resolution IPV4 address", true);
            btn.setAttribute("prompt", "Set and IPV4 address ANNDLE points to.");
        }

        this.rel_has_rt_ipv6 = MEMG.getHasRelon(this.all_relons, MEM.resolves_to_ipv6.temp_nid);
        if (this.rel_has_rt_ipv6==null) {    
            var rel_param_rt_ipv6 = MEMG.getParamRelon(this.all_relons, MEM.resolves_to_ipv6.temp_nid);
            var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_ANNDLE_EDIT, rel_param_rt_ipv6, "set the resolution IPV6 address", true);
            btn.setAttribute("prompt", "Set and IPV6 address ANNDLE points to.");
        }

    }
}