
 
/**
 * general fund
 */
 class dossier_fund extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        console.log("%c dossier_fund", TALK.bgredbig);
        super($pgui, $secondary, $third, $misc);
    }
    initASYNC = async($pguicopy)=>{
        ANNE.A.removeSelf(this.el_bebox_img);
        
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);
        await this.getBalance();

        //take away the be box
        ANNE.A.hide(this.el_idsbox);
        ANNE.A.addRemoveClass(this.el_content, "doss-body-box-full", "doss-body-box");

        this.paidOut();

        this.doAltBES(this.el_content);
        await this.doAllHas(this.el_content);    //generic.

        //events in the body
        //this.doEvents();
        this.addAwarvu();

        //ANNE.A.smartScroll("scrollable_"+this.ID, 22);
    }

    /**
     */
    paidOut = function() {
        this.nObj.printRelons();
        var sys_msg_rels = MEMG.getSysMsgRelons(this.nObj.outs, MEM.winner_payout.temp_nid);
        if (sys_msg_rels.length==0) {
            ANNE.A.ezEl(this.el_content, "div", "simple-row text-warning-lbl", "No payouts yet");
            return;
        }

        var tbl_cols = [
            {   neuron_link:false,
                relon_link:false,
                title:"block",
                prop:"height",
                class1:"annid-block",
                classH:"annid-block-H",
                s_prop:"block",
                s_type:"numeric"
            },
            {   neuron_link:false,
                relon_link:true,
                title:"txid",
                prop:"txid",
                class1:"annid-txid",
                classH:"annid-txid-H",
            },
            {   neuron_link:false,
                relon_link:false,
                title:"winning digits",
                prop:"to_s",
                class1:"annid-txid",
                classH:"annid-txid-H",
            },
            {   
                neuron_link:false,
                relon_link:false,
                title:"payout",
                prop:"annies",
                class1:"annid-txid",
                classH:"annid-txid-H",
                formatter:"ezAnneDisplayApprox"
            }];

        var boosties_winner_data = [];
        
        for (var s=0; s < sys_msg_rels.length; s++) {
            var sys_rel = sys_msg_rels[s];
            if (sys_rel.to_type!=TO_TYPE_STRING) continue;
            var bwd = {annies:sys_rel.annies, txid:sys_rel.txid, to_s:sys_rel.to_s, height:sys_rel.time};
            boosties_winner_data.push(bwd);
        }

        var bb = this.el_content.getBoundingClientRect();
        var estimatedTableBodyTop = 52+bb.top;

        //($pgui, $bDOHEADING=true, $heading_prop="title", $dcf=".smart-scroll-framer", $YBUF=52
        var tableObj = new neuron_table(null, true, "title", ".smart-scroll-framer", 92);
        tableObj.setManualCols(tbl_cols, boosties_winner_data);

        tableObj.buildDOMTable(this.el_content, estimatedTableBodyTop, null, true, true);
    }
}