
class gui_data {
    constructor() {
        this.pos1=0;
        this.pos2=0;
        this.pos3=0;
        this.pos4=0;
        this.elmnt = null;
    }
}

//one 
var GUI_DATA = new gui_data();

class gui_drag {
    constructor() {
    }
    static makeDraggable = function ($divid) {
        gui_drag.dragElement(document.getElementById($divid));
    }
    static closeDragElement = function () {
        document.onmouseup = null;
        document.onmousemove = null;
    }
    static dragElement = function ($elmnt) {
        GUI_DATA.pos1 = 0;
        GUI_DATA.pos2 = 0;
        GUI_DATA.pos3 = 0;
        GUI_DATA.pos4 = 0;
        GUI_DATA.elmnt = $elmnt;
        if (document.getElementById($elmnt.id + "_header")) {
            document.getElementById($elmnt.id + "_header").onmousedown = gui_drag.dragMouseDown;
        } 
        else {
            $elmnt.onmousedown = gui_drag.dragMouseDown;
        }
    }
    static dragMouseDown = function ($e) {
        $e = $e || window.event;
        $e.preventDefault();
        GUI_DATA.pos3 = $e.clientX;
        GUI_DATA.pos4 = $e.clientY;
        document.onmouseup = gui_drag.closeDragElement;
        document.onmousemove = gui_drag.elementDrag;
    }
    static elementDrag = function ($e) {
        $e = $e || window.event;
        $e.preventDefault();
        GUI_DATA.pos1 = GUI_DATA.pos3 - $e.clientX;
        GUI_DATA.pos2 = GUI_DATA.pos4 - $e.clientY;
        GUI_DATA.pos3 = $e.clientX;
        GUI_DATA.pos4 = $e.clientY;
        GUI_DATA.elmnt.style.top = (GUI_DATA.elmnt.offsetTop - GUI_DATA.pos2) + "px";
        GUI_DATA.elmnt.style.left = (GUI_DATA.elmnt.offsetLeft - GUI_DATA.pos1) + "px";
    }
}

class gui_drag_guid {
    constructor() {
    }
    static makeDraggable = function ($divid, $guid) {
        gui_drag_guid.dragElement(document.getElementById($divid+"_"+$guid), $divid, $guid);
    }
    static closeDragElement = function () {
        document.onmouseup = null;
        document.onmousemove = null;
    }
    static dragElement = function ($elmnt, $divid, $guid) {
        GUI_DATA.pos1 = 0;
        GUI_DATA.pos2 = 0;
        GUI_DATA.pos3 = 0;
        GUI_DATA.pos4 = 0;
        GUI_DATA.elmnt = $elmnt;
        if (document.getElementById($divid+"_header"+"_"+$guid)) {
            document.getElementById($divid+"_header"+"_"+$guid).onmousedown = gui_drag_guid.dragMouseDown;
        } 
        else {
            $elmnt.onmousedown = gui_drag_guid.dragMouseDown;
        }
    }
    static dragMouseDown = function ($e) {
        $e = $e || window.event;
        $e.preventDefault();
        GUI_DATA.pos3 = $e.clientX;
        GUI_DATA.pos4 = $e.clientY;
        document.onmouseup = gui_drag_guid.closeDragElement;
        document.onmousemove = gui_drag_guid.elementDrag;
    }
    static elementDrag = function ($e) {
        $e = $e || window.event;
        $e.preventDefault();
        GUI_DATA.pos1 = GUI_DATA.pos3 - $e.clientX;
        GUI_DATA.pos2 = GUI_DATA.pos4 - $e.clientY;
        GUI_DATA.pos3 = $e.clientX;
        GUI_DATA.pos4 = $e.clientY;
        GUI_DATA.elmnt.style.top = (GUI_DATA.elmnt.offsetTop - GUI_DATA.pos2) + "px";
        GUI_DATA.elmnt.style.left = (GUI_DATA.elmnt.offsetLeft - GUI_DATA.pos1) + "px";
    }
}


