
/** 
  */
class gui_stuff {
    constructor() {
        this.ANNE = null;
        this._el_stats = "anne_memstats";         
    }  


    /** 
     * @author {Mr.Scatman}
     */
    init=function($ANNE) {
        this.ANNE = $ANNE;
    }
    
    /** 
     * Set a memstats div to get memstats printed to the gui
     * 
     * @param {string}
     * @author {Mr.Scatman}
     */
    setMemStatsDivid = function($el_memstats="memstats") { this._el_stats = $el_memstats; }

    

    /** 
     * @author {Mr.Scatman}
     */
    updateMemStats=function() {
        if (this==null || this._el_stats=="" || this._el_stats==undefined) return;
        var stats = "neurons: "+MEM._aNeurons.length;
        stats=stats+"</BR>relons: "+MEM._aRelons.length;
        ANNE.A.setHTML(this._el_stats, stats);
    }



    html_href=function($display, $url, $class="") {
        if($class!="") $class='class="'+$class+'"';
        return '<a href="'+$url+'" '+$class+' target="_blank">'+$display+'</a>';
    }


    getghostIcoSolo=function($ghost_type, $size="120") {
        var ico = "";
        if ($ghost_type=="guto") ico = this.getIco("ghost-upgrade-to-other", $size, "ghost-upgrade");
        else if ($ghost_type=="guta") ico = this.getIco("ghost-upgrade-to-ANNE", $size, "ghost-upgrade");
        else if ($ghost_type=="gutm") ico = this.getIco("ghost-upgrade-to-mine", $size, "ghost-upgrade");
        else if ($ghost_type=="hanaicollab") ico = this.getIco("hanai-collab", $size, "ghost-upgrade");
        else if ($ghost_type=="boosties") ico = this.getIco("boosties", $size, "");
        else return "";
        return ico;
    }



    /** 
    * @author {Mr.Scatman}
    */
    getIco=function($type, $w=22, $class="img-ico", $style="") {
        var white = "_white";
        var ico="";
        var style = "";
        if ($style!="") style = "style ='"+$style+"'";
        if ($type=="boosties") ico="<span title='add boosties' "+style+"><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/boosties"+white+"_ico.png' alt=''></img></span>";
        else if ($type=="TREE") ico="<span title='tree' "+style+"><img class='"+$class+"' width='22px' height='22px' src='"+ANNE.___root+"/imgs/TREE"+white+"_ico.png' alt=''></img></span>";
        else if ($type=="DS") ico="<span title='data source' "+style+"><img class='"+$class+"' width='22px' height='22px' src='"+ANNE.___root+"/imgs/DS"+white+"_ico.png' alt=''></img></span>";
        else if ($type=="DOSSIER") ico="<span title='dossier view' "+style+"><img class='"+$class+"' width='22px' height='22px' src='"+ANNE.___root+"/imgs/ico_dossier"+white+".png' alt=''></img></span>";
        else if ($type=="delete"||$type=="bin") ico='<span class="ico-delete">&#128465;</span>';
        else if ($type=="add") ico = '<span class="ico-add">"&#x2295;</span>';
        else if ($type=="HANAI") ico = "<span class='ico-hanai'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/hanai64_ico.png' alt=''></img></span>";
        else if ($type=="ALEXANNDRIA") ico="<span title='library of alexanndria'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/alexanndria_ico.png' alt=''></img></span>";
        else if ($type=="REMEMBERZ") ico="<span><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/brain_ico.png' alt=''></img></span>";
        else if ($type=="ANDY") ico="<span title='ANDY rights'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/andy_ico.png' alt=''></img></span>";
        else if ($type=="ANJ") ico="<span title='anjucator'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/ANJ_ico.png' alt=''></img></span>";
        else if ($type=="MERGE") ico="<span title='Merge'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/ico_merge.png' alt=''></img></span>";
        else if ($type=="MINER") ico="<span title='miner ico'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/miner_ico.png' alt=''></img></span>";
        else if ($type=="ANNTHENAEUM") ico="<span title='Annthenauem'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/annth_ico.png' alt=''></img></span>";
        else if ($type=="TABLE") ico="<span title='table view'><img class='"+$class+"'  width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/TABLE_ico.png' alt=''></img></span>";
        else if ($type=="ANNET") ico="<span title='ANNET neuromorphic hypergraph'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/ANNET_ico.png' alt=''></img></span>";
        else if ($type=="APLEX") ico="<span title='marketplace'><img class='"+$class+"'  width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/APLEX_ico.png' alt=''></img></span>";
        else if ($type=="DS") ico="<span title='data source'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/DS_ico.png' alt=''></img></span>";
        else if ($type=="TREE") ico="<span title='tree'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/TREE_ico.png' alt=''></img></span>";
        else if ($type=="SEND") ico="<span title='tree'><img class='"+$class+"' width='"+$w+"px' height='"+$w+"px' src='"+ANNE.___root+"/imgs/SEND_ico.png' alt=''></img></span>";
        else if ($type=="RECEIPT") ico='<i class="ai-receipt"></i>';
        else if ($type=="ghost-upgrade-to-ANNE") ico="<span title='upgrade ghost data to ANNE global data' "+style+"><img class='"+$class+"' width='"+$w+"px' src='"+ANNE.___root+"/imgs/ghost_upgrade_anne_ico.png' alt=''></img></span>";
        else if ($type=="ghost-upgrade-to-mine") ico="<span title='upgrade ghost data to your real data' "+style+"><img class='"+$class+"' width='"+$w+"px' src='"+ANNE.___root+"/imgs/ghost_upgrade_mine_ico.png' alt=''></img></span>";
        else if ($type=="ghost-upgrade-to-other") ico="<span title='collab relon' "+style+"><img class='"+$class+"' width='"+$w+"px' src='"+ANNE.___root+"/imgs/ghost_upgrade_other_ico.png' alt=''></img></span>";
        else if ($type=="hanai-collab") ico="<span title='hanai collab' "+style+"><img class='"+$class+"' width='"+$w+"px' src='"+ANNE.___root+"/imgs/hanai_collab_ico.png' alt=''></img></span>";
        else if ($type=="wikipedia") ico="<span title='wikipedia' class='center-all' style='min-width:"+$w+"px'><span class='ai-wikipedia'></span></span>";
        
        else alert("WE DONT HAVE THAT ICO '"+$type+"', SORRY");

        return ico;
    }


    /** 
     * @author {Mr.Scatman}
     */
     ___buildListDisplayFor=async ($nObj,$types,$bCHASE=true,$bSLIM=false) => {
        if(ANNE.MEM_UDF!=null&&typeof ANNE.MEM_UDF._udf_buildListDisplayFor==="function") {
            return ANNE.MEM_UDF._udf_buildListDisplayFor($nObj,$types,$bCHASE,$bSLIM);
        }
        var all=MEMG.getParentLineRelons($nObj,$types);
        var aDisplay=[];
        if ($types.indexOf(TYPE_SYS)!=-1) var d1=await this.___genListDisplayFor($nObj,all.sys,$bCHASE,aDisplay,$bSLIM);
        if ($types.indexOf(TYPE_BE)!=-1) var d2=await this.___genListDisplayFor($nObj,all.bes,$bCHASE,aDisplay,$bSLIM);
        if ($types.indexOf(TYPE_PARAM)!=-1) var d3=await this.___genListDisplayFor($nObj,all.params,$bCHASE,aDisplay,$bSLIM);
        if ($types.indexOf(TYPE_HAS)!=-1) var d4=await this.___genListDisplayFor($nObj,all.has,$bCHASE,aDisplay,$bSLIM);
        return aDisplay;
    }

    /**
     * We want to return an array of value/text objects for use in a simple 
     * display DD  (most likely produced in-full by buildListDisplayFor)    
     * 
     * @author {Mr.Scatman} 
     */
     ___genListDisplayFor=async ($nObj,$arr,$bCHASE=true,$ptrArray=null,$bSLIM=false) => {
        if(ANNE.MEM_UDF!=null&&typeof ANNE.MEM_UDF._udf_genListDisplayFor==="function") {
            return await ANNE.MEM_UDF._udf_genListDisplayFor($nObj,$arr,$bCHASE,$ptrArray,$bSLIM);
        }
        var arr=[];
        for(var a=0;a<$arr.length;a++) {
            var pObj=$arr[a];
            if(pObj.type==TYPE_BE || pObj.type==TYPE_SYS) {
                if(pObj.from_nid!=$nObj.nid) continue;
            }
            //if(pObj.reln==MEM.key.nid) continue;   //no need to show the key
            if(pObj.type==TYPE_BE && pObj.reln==MEM.name.nid) continue;   //we know our name

            //if this relon is inhibited by the nObj or the from (parent line), do not include it
            if($nObj.inhibit_txs!=undefined&&$nObj.inhibit_txs.indexOf(pObj.txid)!=-1) continue;
            if(pObj.from_nid!=$nObj.nid) {
                var parentNOBJ=MEMG.getNeuronByTempNid(pObj.f);
                if(parentNOBJ.inhibit_txs!=undefined&&parentNOBJ.inhibit_txs.indexOf(pObj.txid)!=-1) continue;
            }
            arr.push(pObj);
        }


        //we need to get basic display info about everything in the pObjs
        if($bCHASE==true&&arr.length) {
            var bSKIPIFHASTEXT=true;
            var bDOEXTRAS=false;
            var aNidsList=MEMG.extractAllFromRelons(arr,bSKIPIFHASTEXT,bDOEXTRAS,[],true);
            if(aNidsList.length&&ANNE.CHASE!=null) {
                var aRelons=await ANNE.CHASE.lookupMinTNids(aList);
            }
        }

        for(var a=0;a<arr.length;a++) {
            var pObj=arr[a];
            var fNObj=MEMG.getNeuronByTempNid(pObj.f);
            var inherit="";
            var temp="";
            if(fNObj.nid!=$nObj.nid) {
                if($bSLIM==true) continue;
                inherit=" (I)";
            }
            if(pObj.temp==true) continue;

            var msg="";
            var bNOFONT=true;
            var talkmsg="";
            if(ANNE.TALK!=null) talkmsg=TALK.humanReadableRelon(pObj,$bSLIM,bNOFONT);
            talkmsg=msg+talkmsg+inherit+temp;
            if($ptrArray!=null) $ptrArray.push({"value": pObj.txid,"text": talkmsg});
        }
        return;
    }



    /** 
     * @author {Mr.Scatman}
     */
     ___madeDDfromValTextArr=function($el_dd,$aList,$msg) {
        if(ANNE.MEM_UDF!=null&&typeof ANNE.MEM_UDF._udf_madeDDfromValTextArr==="function") {
            return ANNE.MEM_UDF._udf_madeDDfromValTextArr($el_dd,$aList,$msg);
        }
        var dropdown=document.getElementById($el_dd);
        var headerO=document.createElement("option");
        headerO.setAttribute("data-divider",true);
        headerO.setAttribute("disabled",true);
        headerO.innerHTML=$msg;
        headerO.style.backgroundColor="#ccc";
        headerO.style.color="#000";
        dropdown.append(headerO);

        for(var t=0;t<$aList.length;t++) {
            var opt=document.createElement("option");
            headerO.setAttribute("value",$aList[t].value);
            headerO.innerHTML=$aList[t].text;
            document.append(opt);
        }
        dropdown.setAttribute('selectedIndex',0);
        ANNE.A.show(dropdown);
    }


    /** 
     * @author {Mr.Scatman}
     */
     _deleteAdminAction=function($action) {
        alert("what is this?")
        for (var a = 0; a < this._aActions.length; a++) {
            var action = this._aActions[a];
            if (action._nid==$action._nid) {
                this._aActions.splice(a, 1);
                return;
            }
        }
        return;
    }


    //just calc it here.  no need to do the uom functionality
    doAnniesToAnneSpanFull = function($el, $pre="", $annies=0) {
        var annecoin = $annies/100;
        return this.doAnneSpan($el, $pre, annecoin);
    }

    _convert = function ($val, $uom) {
        var post = "";
        if ($uom.unit_lbl.length) post=" "+$uom.unit_lbl;
        if ($uom.symbolHTML) post=post+$uom.symbolHTML;
        var factor = Math.ceil(1/$uom.factored);
        var total = Math.round(($uom.factored*parseFloat($val))*factor)/factor;
        var thisconv = {val:$val, total:total, post:post};
        if ($uom.conversions==undefined) $uom.conversions = [];
        $uom.conversions["_"+$val]=thisconv;
        return thisconv;
    }

    
    /**
     * 
     * @param {*} $el 
     * @param {*} $pre 
     * @param {*} $anne 
     */
    doAnneSpan = function($el, $pre, $annecoin=0, $post="") {
        if ($pre!="") ANNE.A.ezEl($el, "span", '', $pre);
        return ANNE.A.ezEl($el, "span", 'annecoin', UTILS.formatNumberCommas($annecoin) + this.getAnneImgHtml(16, $annecoin)+$post);
    }
    

    /**
     * Just to show how to do it...
     * @param {*} $val 
     * @param {*} $size 
     * @returns 
     */
    doAnniesToANNE_HTML = function($val, $size=16) {
        var uom = MEM.unitOfMeasure(MEM.annies);    //annies is a uo measure->uo account->uo crypto
        var thisconv = "";
        if (uom.conversions!=undefined && uom.conversions["_"+$val]!=undefined) {
            thisconv = uom.conversions["_"+$val];
        }
        else thisconv = this._convert($val, uom);
        return UTILS.formatNumber(thisconv.total) + this.getAnneImgHtml($size, thisconv.total);
    }

    /** 
     * @author {Mr.Scatman}
     */
    formatMultiTotal=function($el, $lbl="balance", $annies=0, $className="") {
        function commas(x) {
            return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g,",");
        }
        var annecoin = "<span class='annecoin ibi'>"+commas((Math.round(1000*parseFloat($annies/ANNE.ANNE_TO_ANNIES)))/1000)+this.getAnneImgHtml('20px')+"</span>";
        if ($el!=null) ANNE.A.empty($el);
        ANNE.A.ezlblSpan($el, $lbl, annecoin, $className);
    }


    /** 
     * @author {Mr.Scatman}
     */
    formatANNECoin=function($annies) {
        return "<span class='annecoin-amt'>"+ANNE.UTILS.formatNumber($annies)+"</span><img title='ANNE coin' class='anneico-small' src='"+ANNE.___anneico_path+"'></img>";
    }
    formatANNIES_to_ANNECoin=function($annies) {
        return "<span class='annecoin-amt'>"+ANNE.UTILS.formatNumber($annies/ANNE.ANNE_TO_ANNIES)+"</span><img title='ANNE coin' class='anneico-small' src='"+ANNE.___anneico_path+"'></img>";
    }



    /** 
     * @author {Mr.Scatman}
     */
    getAnniesImgHtml($size=24, $val="", $class="ibi") {
        return "<img class='"+$class+"' width='"+$size+"' height='"+$size+"' title='"+$val.toLocaleString()+" (10,000 annies in 1 ANNE coin)' class='annieico-small' src='"+ANNE.___annieico_path+"'></img>";
    }


    /** 
     * @author {Mr.Scatman}
     */
    getAnneImgHtml($size=24, $val="", $class="ibi icofix") {
        return "<img class='"+$class+"' width='"+$size+"' height='"+$size+"' title='"+$val.toLocaleString()+"' class='anneico-small' src='"+ANNE.___anneico_path+"'></img>";
    }



    ___generateChildrenDD=function($el_dd, $classNObj, $defaultMsg="") {
        var nObjs = MEMG.getNObjsFromTempNidList($classNObj.children);
        nObjs.sort(ANNE.UTILS.sortByTextNoCase);
        this.___generateDDFromNObjs($el_dd,nObjs,$defaultMsg);
    }


     ___generateDDFromNObjs=function($el_dd,$nObjs,$defaultMsg="choose the data this point to") {
        if(typeof this._udf_generateDDFromNObjs==="function") {
            return this._udf_generateDDFromNObjs($el_dd,$nObjs,$defaultMsg);
        }
        var dropdown=document.getElementById($el_dd);
        ANNE.A.empty(dropdown);
        var indent="&#9494;";
        var space='&#160;';
        console.log("(generateDDFromNObjs)");
        for(var n=0;n<$nObjs.length;n++) {
            var nObj=$nObjs[n];
            var text=nObj.text;
            if(text=="") text=nObj.nid;
            if(nObj.temp_nid==ANNE.MEM.class.temp_nid) text="any class neuron";
            var spaces="";
            if(nObj.be_lvl>0) {
                for(var x=0;x<nObj.be_lvl;x++) spaces+=space;
                text=spaces+indent+text;
            }
            var opt=document.createElement("option");
            opt.setAttribute("value",nObj.nid);
            opt.innerHTML=nObj.text;
            dropdown.append(opt);
        }

        var opt=document.createElement("option");
        opt.setAttribute("value","");
        opt.innerHTML=$defaultMsg;
        dropdown.append(opt);
        dropdown.setAttribute('selectedIndex',0);
    }


    


    /**
     * PLAY A SOUND
     * 
     * Play a sound for whatever just happened.
     *
     * This helps me debug and allows another sense to be active in the experience.
     * Users can turn off sounds if they like.
     * 
     * @author {Mr.Scatman}
     */
    playSound=async($divid)=> {
        if (this._pref_volume_onoff!==-1) ANNE.A.play($divid);
    }



    /** 
     * @author {Mr.Scatman}
     */
     doDefaultImg=function($div, $imgElId, $w=360, $h=180, $imgClassAdd="") {
        ANNE.A.doImage($div, $imgElId, ANNE.___root+"/imgs/unknown.png", $w, $h, $imgClassAdd);
    }


     doDefaultImgDyno=function($div, $imgElId, $imgClassAdd="left_dyno_w") {
        ANNE.A.doImageDyno($div, $imgElId, ANNE.___root+"/imgs/unknown_.png", $imgClassAdd);
    }



    /** 
     * @author {Mr.Scatman}
     */
    ___initInstDDWithOverrideArray=function($el_dd,$defaultMsg,$nids,$bSEARCHOK=false) {
        var nObjs=MEMG.getNObjsFromTempNidList($nids);
        return this.___genDDArray($el_dd,$defaultMsg,[],[],false,false,false,false,nObjs,$bSEARCHOK);
    }


    /** 
     * DEPRECATED in the EXT
     * handler of building all DDs.. 
     * @author {Mr.Scatman}
     */
     ___genDDArray=function($el_dd,$defaultMsg,$disables=[],$adds=[],$bDOTTS=true,
        $bEWV=true,$bDISABLETOP_TT=false,$bDOTEMP=false,$nObjsOverride=[],$searchOK=true) {

        var aNObjs=[];
        var bOVERRIDEMODE=false;
        if($nObjsOverride.length) {
            aNObjs=$nObjsOverride;
            bOVERRIDEMODE=true;
        }
        else {
            aNObjs=MEMG.getAllClasses();
            bOVERRIDEMODE=false;
        }
        if(bOVERRIDEMODE==false) {
            var nonTT=new Object();
            var aOthers=[];
            nonTT["other classes"]=aOthers;
            var TT=new Object();  //array of arrays
            if($adds.length) {
                var easy=new Object();
                easy["easy access"]=$adds;
            }
            var mine=new Object();
            var aMine=[]
            mine["my classes"]=aMine;

            var anne_=new Object();
            var aANNE=[];
            anne_["ANNE classes"]=aANNE;

            var aTTs=MEMG.getSysToTypes();
            var aMineObjs=MEM.getMineNObjs();
            for(var m=0;m<aMineObjs.length;m++) {
                var nObj=aMineObjs[m];
                if(nObj.mine==true) {
                    if(nObj.bes[0]!=MEM.class.temp_nid) {
                        var beNOBJ=MEMG.getNeuronByTempNid(nObj.bes[0]);
                        if(beNOBJ!=null&&beNOBJ.mine) continue;
                    }
                    aMine.push(nObj);
                    continue;
                }
            }

            for(var i=0;i<aNObjs.length;i++) {
                var nObj=aNObjs[i];
                if($bDOTTS==false && nObj.bTERMINATING_TYPE==true) continue;
                if(nObj.temp==true && $bDOTEMP==false) continue;

                //push user's top classes (we will iterate through the children)
                if(nObj.mine==true) continue;

                if(useradopted.indexOf(nObj.temp_nid)!==-1) {
                    aAdopted.push(nObj);
                    continue;
                }
                if(MEM.ANNE.owns.indexOf(nObj.temp_nid)!=-1) {
                    if(nObj.be=="class") aANNE.push(nObj); //only push top-classes here
                    continue;
                }
            }

            if($bDOTTS==true) {
                var aTTs=MEMG.getSysToTypes();
                for(var t=0;t<aTTs.length;t++) {
                    var nObj=aTTs[t];
                    var isdefined=TT[nObj.text+"s"];
                    if(isdefined==undefined) TT[nObj.text+"s"]=[nObj];
                    else TT[nObj.SYS_ALIAS].push(nObj);
                }
            }

            var data=[];

            //user defined classes (all together)
            if($adds.length) data=this._prepSelectData(easy,$disables,false);

            if(aMine.length) {
                var datam=this._prepSelectData(mine,$disables,$bDISABLETOP_TT);
                data=data.concat(datam);
            }

            //all terminating type classes (ie, anne stuff)
            if($bDOTTS==true) {
                var data1=this._prepSelectData(TT,$disables,$bDISABLETOP_TT);
                if(data1.length) data=data.concat(data1);
            }

            if(aANNE.length) {
                var dataAnne=this._prepSelectData(anne_,$disables,$bDISABLETOP_TT);
                data=data.concat(dataAnne);
            }

            //all other classes (ie, anne stuff)
            var data2=this._prepSelectData(nonTT,$disables,$bDISABLETOP_TT);
            if(data2.length) data=data.concat(data2);
        }

        //build 
        else {
            var data=this._prepSelectDataOverride($nObjsOverride,"valid selections");
        }

        console.log(data);
        var ddel = ANNE.A.__getEl($el_dd);    //gets it if it is a string for id/class or already an element.
        
        for(var d=0; d < data.length; d++) {
            var section=data[d];
            var opt = ANNE.A.createElement(ddel, "option", "option-group-heading", section.text);
            opt.setAttribute("disabled",true);
            opt.value="";
            for(var d=0; d < section.children.length; d++) {
                var dobj = section.children[d];
                var opt = ANNE.A.createElement(ddel, "option", "", dobj.text, dobj.value);
            }
        }
        ddel.value="";
        return;
    }


    /** 
     * handler of building all DDs.. 
     * @author {Mr.Scatman}
     */
     _prepSelectDataOverride=function($arr,$heading) {
        console.log("(_prepSelectDataOverride)");
        var results=[];
        if($arr.length) {
            var items=[];
            function textThenType($a,$b) {
                if($a==undefined||$a==null||$b==undefined||$b==null) return 0;
                if($a.ntype<$b.ntype) return -1;
                else if($a.ntype>$b.ntype) return 1;
                else {
                    if($a.text.toUpperCase()<$b.text.toUpperCase()) return -1;
                    else if($a.text.toUpperCase()>$b.text.toUpperCase()) return 1;
                    else return 0;
                }
            }

            function parentThenText($a,$b) {
                if($a==undefined||$a==null||$b==undefined||$b==null) return 0;
                if($a.bes[0]<$b.bes[0]) return -1;
                else if($a.bes[0]>$b.bes[0]) return 1;
                else {
                    if($a.text.toUpperCase()<$b.text.toUpperCase()) return -1;
                    else if($a.text.toUpperCase()>$b.text.toUpperCase()) return 1;
                    else return 0;
                }
            }

            //we actually want to show the parent..
            $arr.sort(parentThenText);

            function doHeading($nObj) {
                var par=$nObj.bes[0];
                if(_pdone.indexOf(par)!=-1) return;
                _pdone.push(par);
                var beNOBJ=MEMG.getNeuronByTempNid(par);
                items.push({id: par,text: '<div>'+beNOBJ.text+' ('+beNOBJ.nid+')</div>',value: beNOBJ.nid,disabled: true});
            }

            var _pdone=[];

            for(var a=0;a<$arr.length;a++) {
                var nObj=$arr[a];
                if(nObj.temp_nid==MEM.class.temp_nid) continue;
                doHeading(nObj);
                var indent="&#9494;";
                var space='&#160;';
                if(nObj.be_lvl==0) space="";
                else {
                    for(var i=0;i<nObj.be_lvl-1;i++) {space+='&#160;';}
                    space=space+indent;
                }
                items.push({id: nObj.temp_nid,text: '<div>'+space+nObj.text+' ('+nObj.nid+')</div>',value: nObj.nid});
            }
            results.push({text: $heading,children: items});
        }
        return results;
    }


    /** 
     * handler of building all DDs.. 
     * @author {Mr.Scatman}
     */
    _prepSelectData=function($arr,$disables=[],$bDISABLETTTOP=false) {
        var results=[];
        var keys=Object.keys($arr);
        for(var k=0;k<keys.length;k++) {
            var type=keys[k];
            var items=[];
            var arr=$arr[type];
            if(arr.length) {
                arr.sort(ANNE.UTILS.sortByTextNoCase);
                for(var a=0;a<arr.length;a++) {
                    var nObj=arr[a];
                    if($disables.length&&$disables.indexOf(nObj.nid)!=-1) {
                        items.push({id: nObj.temp_nid,disabled: true,text: '<div>'+nObj.text+' ('+nObj.nid+')</div>',value: nObj.nid});
                    }
                    else if($bDISABLETTTOP==true&&nObj.bTERMINATING_TYPE==true); //still do the children.
                    else items.push({id: nObj.temp_nid,text: '<div>'+nObj.text+' ('+nObj.nid+')</div>',value: nObj.nid});
                    var children=nObj.children;
                    if(children.length) this._indentChildren(children,items,1,$disables);
                }
                if(items.length) results.push({text: type,children: items});
            }
        }
        //console.log(results);
        return results;
    }



    /** 
     * helper in DDs to build intended items according to the BE dimension. 
     * @author {Mr.Scatman}
     */
    _indentChildren=function($children,$arr,$level,$disables=[]) {
        var level_max=12;
        if($children.length) {
            var children=[];    //our $children array is temp_nids and we can't sort by text until we get it!
            for(var st=0;st<$children.length;st++) {
                var temp_nid=$children[st];
                var nObj=MEMG.getNeuronByTempNid(temp_nid);
                children.push(nObj);
            }
            children.sort(ANNE.UTILS.sortByTextNoCase);
            for(var c=0;c<children.length;c++) {
                var nObj=children[c];
                if(nObj.ntype==NTYPE_INST) continue;
                if($disables.length&&$disables.indexOf(nObj.temp_nid)!=-1) continue;
                var d="";
                var indent="&#9494;";
                var space='&#160;';
                for(var i=0;i<$level-1;i++) {space+='&#160;';}
                d=space+indent+nObj.text+" ("+nObj.nid+")";
                $arr.push({id: nObj.temp_nid,text: '<div>'+d+"</div>",value: nObj.nid});
                if(nObj.children!=undefined&&$level<level_max) this._indentChildren(nObj.children,$arr,$level+1);
            }
        }
    }

    makeAdvancedExternalUrlLink=function($relon) {
        var url=MEMG.__GET_URL($relon);
        return '<a href="'+url+'" title="external url:'+url+'" target="_blank">external url&nbsp;<i class="ai-external-link-square-alt"></i></a>';
    }
    makeExternalUrlLink=function($url) {
        return '<a href="'+$url+'" title="external url:'+$url+'" target="_blank">external url&nbsp;<i class="ai-external-link-square-alt"></i></a>';
    }


    /**
     * Quick helper to get and display the class description of a neuron
     * in an already-present element with expected name.
     * @param {*} $nObj 
     * @param {*} $el_name 
     * @param {*} $ID 
     * @returns 
     */
    addClassDesc = function($nObj, $el_name="", $ID=null) {
        if ($nObj==null) return;
        if ($el_name=="") return;

        if ($ID==null) var el_class_desc = document.getElementById($el_name+"_class_desc");
        else var el_class_desc = document.getElementById($el_name+"_class_desc_"+$ID);
        if (el_class_desc==null) return;

        var desc = $nObj.getClassDesc();
        if (desc!=null && desc.length>0) {
            el_class_desc.innerHTML = desc;
            ANNE.A.showParent(el_class_desc);
            ANNE.A.show(el_class_desc);
        }
    }


    /** 
     * 
     * @author {Mr.Scatman} 
     */
    disambigHTMLStr=async($el, $nObj, $skips=[])=> {
        if ($el==undefined || $el==null) return;
        if ($nObj==null) return;

        var el = ANNE.A.empty($el);
        var disp_class = ANNE.TALK.getNeuronDisplayClass($nObj);
        
        var afile = await ANNE.IMAGES.getAnyValidImgAFILE($nObj);
        if (afile!=null) {
            var imgbtn = ANNE.A.imgButtonB64(el, "", afile, "circ-img", null);
            if (imgbtn!=null) imgbtn.setAttribute("nid", imgNOBJ.nid);
        }

        var span2 = document.createElement("span");
        el.append(span2);
        span2.classList="neuron-choice-info-part";
        span2.innerHTML = "<span><b>"+$nObj.text+"</b></span><span><b>nid:</b>"+$nObj.nid+"</span>";
        span2.classList.add(disp_class);

        if ($nObj.bes.length && $skips.indexOf("be")==-1) {
            var beNOBJ = MEMG.getNeuronByTempNid($nObj.bes[0]);
            var span3 = document.createElement("span");
            el.append(span3);
            span3.classList="neuron-choice-info-part";
            span3.innerHTML = beNOBJ.text;
            var disp_class = TALK.getNeuronDisplayClass(beNOBJ);
            span3.classList.add(disp_class);
        }

        if ($nObj.owned_by!="" && $skips.indexOf("ob")==-1) {
            var ownedBYNOBJ = MEMG.getOrMakeIfNew($nObj.owned_by);
            var span4 = document.createElement("span");
            el.append(span4);
            span4.classList="neuron-choice-info-part";
            span4.innerHTML = "<b>owner:</b>"+ownedBYNOBJ.nid;
            var disp_class = TALK.getNeuronDisplayClass(ownedBYNOBJ);
            span4.classList.add(disp_class);
        }

        if ($nObj.sponsored_by!="" && $skips.indexOf("sp")==-1) {
            var sponsoredBYNOBJ = MEMG.getOrMakeIfNew($nObj.sponsored_by);
            var span5 = document.createElement("span");
            el.append(span5);
            span5.classList="neuron-choice-info-part";
            span5.innerHTML = "<b>sponsor:</b>"+sponsoredBYNOBJ.nid;
            var disp_class = TALK.getNeuronDisplayClass(sponsoredBYNOBJ);
            span5.classList.add(disp_class);
        }

        if ($nObj.aka!=null && $skips.indexOf("aka")==-1) {
            var span = document.createElement("span");
            span.classList="neuron-choice-info-part";
            span.innnerHTML = "<b>also known as</b>"+$nObj.aka.join("/");
            el.append(span);
        }
        ANNE.A.show(el);
    }
}


var GUI_STUFF = new gui_stuff();