//extras

class annode_auth  {
    constructor($resultObj){
        if ($resultObj==undefined || $resultObj==null) return;
        this.annode_time = $resultObj.annode_time;
        this.annode_pubKey = $resultObj.annode_pubKey;
        this.annode_id = $resultObj.annode_id;
        this.annode_drl = $resultObj.annode_drl;
        this.next_proof_id = $resultObj.next_proof_id;
        if(this.annode_drl==undefined) this.annode_drl=1000;

        //we can show these in a gui of some-kind.
        this.network = $resultObj.network;
        if (this.network==undefined) this.network = false;

		this.ANNDLE_active = $resultObj.ANNDLE_active;
        if (this.ANNDLE_active==undefined) this.ANNDLE_active = false;
        
		this.ASDF_active = $resultObj.ASDF_active;
		if (this.ASDF_active==undefined) this.ASDF_active = false;
        
        this.BOUNTY_active = $resultObj.BOUNTY_active;
        if (this.BOUNTY_active==undefined) this.BOUNTY_active = false;
        
        this.PDNS_active = $resultObj.PDNS_active;
        if (this.PDNS_active==undefined) this.PDNS_active = false;
        
        this._nonce = "";
        this._encrypted_sk = "";

        //used to prove annode identity.
        this._nonce2 = "";
        this._encrypted_proof = "";
    }


    //These are hex strings from the ANNODE we are handshook with.
    //NOTE: We will neeed to change the LS user storage object to allow also for multiple
    //annodes for the same origin/app/user if we want to store more than the "last"
    //annode handshook with for the origin/app/user.
    //At present this is location in the annode code folder html/ui/annewallet/js/localstorage.js.

    //We already decrypted the shared key from these values and 
    //then encrypted them with a simpler encryption for "us" in our LS User object.
    //This is a backup for testing.
    set encrypted_sk ($esk) { this._encrypted_sk=$esk};
    get encrypted_sk(){ return this.encrypted_sk;}
    set encrypted_proof ($ep) { this._encrypted_proof=$ep};
    get encrypted_proof(){ return this._encrypted_proof;}
    set nonce ($nonce) { this._nonce=$nonce};
    get nonce () { return this._nonce; }
    set nonce2 ($nonce2) { this._nonce2=$nonce2};
    get nonce2 () { return this._nonce2; }
    get time() { return this.annode_time; }
    get pubKey() { return this.annode_pubKey; }
    get id() { return this.annode_id; }
    drl=function() { 
        return this.annode_drl; 
    }
}