var SENDQ = {};
SENDQ.aQ = [];

//callbacks
SENDQ.__refreshCallbackTemp = null;

SENDQ.__mustRunPreTestFunction = null;
SENDQ.__refreshCallback = null;

SENDQ._bDOINGSEND = false;

SENDQ._bSENDQISOPEN=false;                //whether or not the queue is open and visible right now in the DOM
SENDQ._bTEMPSHOWBLOCK = false;            //whether or not we will allow the queue to be displayed (sometimes we do not)
SENDQ._bREGENNEEDED = false;
SENDQ._sender_page = null;


//gui interaction settings.
SENDQ._divid_q = "sendq";
SENDQ._trashColor = "white";
SENDQ._divid_alerts = "";
SENDQ._divid_cart = "";
SENDQ._divid_tx_results = "qrb_txs_list_div";

/**
 * after destroy, these will need to be re-int
 * This is the speed bump from the ico menu (DO WE NEED IT??)
 */
SENDQ.init = function() {
    SENDQ.___sendQueue();
}

SENDQ.destroyAll = function() {
    alert("destroyAll called");
    sendq_refresh.removeEventListener("click", e=>SENDQ.___genQgui());
    sendq_btn.removeEventListener("click", e=>SENDQ.___sendQueue());
}

SENDQ.setAlertsDivid = function ($divid) { SENDQ._divid_alerts = $divid; }
SENDQ.setQDivid = function ($divid="sendq") { 
    SENDQ._divid_q = $divid;
}
SENDQ.setCartDivid = function ($divid) { SENDQ._divid_cart = $divid; }
SENDQ.setTxResultsDivid = function ($divid) { SENDQ._divid_tx_results = $divid; }


SENDQ.auditFoDupeHanai=function() {
    var hanai_nids = [];
    var failure = [];
    for (var a=0; a < SENDQ.aQ.length; a++) {
        var cmdObj = SENDQ.aQ[a];
        if (cmdObj.TXTYPE==ANNE.TXB.TXTYPE_HANAI_OUT_REQ) {
            if (hanai_nids.indexOf(cmdObj.relon.from_nid)!=-1) {
                failure.push(cmdObj.relon.from_nid);
                var nOBJ = MEMG.getNeuronByNid(cmdObj.relon.from_nid);
                if (ANNE.SETTINGS.debug()==true) console.log(nOBJ.text+" already hanaid in index "+a, cmdObj);
                hanai_nids.push(cmdObj.relon.from_nid);
            }
        }
        else if (cmdObj.TXTYPE==ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ) {
            if (hanai_nids.indexOf(cmdObj.relon.to_s)!=-1) {
                failure.push(cmdObj.relon.to_s);
                var nOBJ = MEMG.getNeuronByNid(cmdObj.relon.to_s);
                if (ANNE.SETTINGS.debug()==true) console.log(nOBJ.text+" already hanaid in index "+a, cmdObj);
                hanai_nids.push(cmdObj.relon.to_s);
            }
        }
    }
    if (failure.length) {
        //we need to DELETE one of these collab!!!
        console.warn("AUDIT FAIL!!!!", failure);
        return false;
    }
    return true;
}


/**
 * We have a relon we want to allocate funds for but we do not yet know the nid
 * because it depends upon a neuron being created.
 * $callback only relevent if sendNow is set. (this is the trigger of the queue send)
 */
SENDQ.pendingFromRelon = async($type, $reln, $to_type, $to_s, $TXTYPE, $ge=null, $bSENDNOW=true, $callback=null)=> {
    if (typeof $to_s !== "string" && ($to_s instanceof anne_neuron)==true) {
        console.warn("fix this!  pass the to_s, not the neuron, silly");
        $to_s = $to_s.nid;
    }

    if (SENDQ.aQ.length==0) {
        console.warn("something is wrong -- we must have a prev cmd in the Q to use pending relons!");
        return;
    }

    if ($reln=="" || $to_s=="") {
        console.warn("something is wrong -- reln/to is empty.");
        return;
    }


    var future_relon = {type:$type, from_nid:null, pending_from:"tbd", reln:$reln, to_type:$to_type, to_s:$to_s};
    var cmdObj = TXB.makeChildRelonAPICmd(future_relon, $TXTYPE, TXB.CMD_USE_LAST_NEURON_FORTHISFROM);
    cmdObj.PENDING_DATA=true;
    if ($ge!=null) {
        if (ANNE.SETTINGS.debug()==true) console.log("set ge on cmdObj");
        cmdObj.gui_extras = $ge;
    }

    //tie the prev cmdObj to this one in case it is deleted.
    SENDQ.setPrevAffect(cmdObj);

    //display the badge update in the message area, if relevant.
    SENDQ.cartChange();

    //this will use the generic built-in prompt
    if ($bSENDNOW==true) {
        await SENDQ.___sendQueue($callback);
    }

    return cmdObj;
}


SENDQ.pendingToRelon = async($from_nid, $type, $reln, $to_type, $TXTYPE, $ge=null, $bSENDNOW=true, $callback=null)=> {
    if (SENDQ.aQ.length==0) {
        console.warn("something is wrong -- we must have a prev cmd in the Q to use pending relons!");
        return;
    }
    var future_relon = {type:$type, from_nid:$from_nid, reln:$reln, to_type:$to_type, to_s:null, pending_to_s:"tbd", pending_to_debug:""};
    var cmdObj = TXB.makeChildRelonAPICmd(future_relon, $TXTYPE, TXB.CMD_USE_LAST_NEURON_FORTHISTO_S);
    cmdObj.PENDING_DATA=true;
    if ($ge!=null) {
        cmdObj.gui_extras = $ge;
        if (ANNE.SETTINGS.debug()==true) console.log("set ge on cmdObj");
    }
    
    //tie the prev cmdObj to this one in case it is deleted.
    SENDQ.setPrevAffect(cmdObj);
    
    //display the badge update in the message area, if relevant.
    SENDQ.cartChange();

    //this will use the generic built-in prompt
    if ($bSENDNOW==true) {
        await SENDQ.___sendQueue($callback);
    }
    return cmdObj;
}

/**
 * @param {object} - future relon with pending_from, pending_reln, and/or pending_to_s set. 
 */
SENDQ.pendingDynamicVarRelon = async($future_relon, $bPFROM=false, $bPRELN=false, $bPTO_S=false, $TXTYPE, $ge=null, $bSENDNOW=true, $callback=null)=> {
    if (SENDQ.aQ.length==0) {
        alert("queue ordering wrong -- can't use DYNAMIC without pending relon in 0 slot!")
        console.warn("something is wrong -- we must have a prev cmd in the Q to use pending relons!");
        return;
    }

    //audit the pending from
    if ($bPFROM==true) {
        if ($future_relon.pending_from==undefined) {
            console.warn("malformed pending dynamic var.  Pending from should be defined.");
            return;
        }
        else $future_relon.from_nid=null;//make sure this is set to null
    }
    else if ($future_relon.pending_from!=undefined) {
        console.warn("malformed pending dynamic var.  Pending from should NOT be defined.");
        return;
    }

    //audit the pending reln
    if ($bPRELN==true) {
        if ($future_relon.pending_reln==undefined) {
            console.warn("malformed pending dynamic var.  Pending reln should be defined.");
            return;
        }
        else $future_relon.reln=null;
    }
    else if ($future_relon.pending_reln!=undefined) {
        console.warn("malformed pending dynamic var.  Pending reln should NOT be defined.");
        return;
    }

    //audit the pending to_s
    if ($bPTO_S==true) {
        if ($future_relon.pending_to_s==undefined) {
            console.warn("malformed pending dynamic var.  Pending to_s should be defined.");
            return;
        }
        else $future_relon.to_s=null;
    }
    else if ($future_relon.pending_to_s!=undefined) {
        console.warn("malformed pending dynamic var.  Pending to_s should NOT be defined.");
        return;
    }

    $future_relon.gui_extras = $ge;

    var cmdObj = TXB.makeChildRelonAPICmd($future_relon, $TXTYPE, TXB.CMD_POPULATE_RELON_WITH_VARS);
    cmdObj.PENDING_DATA=true;
    if ($ge!=null) {
        cmdObj.gui_extras = $ge;
        if (ANNE.SETTINGS.debug()==true) console.log("set ge on cmdObj");
    }
    
    //we need an encrypt with annode shared key here, in all cases we use this reln.      
    if ($future_relon.r==MEM.PDN_SECRET.temp_nid && $future_relon.type!=TYPE_PARAM) {
        cmdObj.add_special(TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY);
    }

    //tie the prev cmdObj to this one in case it is deleted.
    SENDQ.setPrevAffect(cmdObj);
    
    //display the badge update in the message area, if relevant.
    SENDQ.cartChange();

    //this will use the generic built-in prompt
    if ($bSENDNOW==true) {
        await SENDQ.___sendQueue($callback);
    }
    return cmdObj;
}


/**
 * This will make a cmd that ONLY updates local memory.
 * It will NOT be broadcasting info but it is critical that we update
 * this relon in MEM.  We have updated a ghost neuron to a real neuron (changed the NID)
 * but we did not yet broadcast this RELON.  It refers to the GHOST in the TO_S so we must
 * update this with the new info.
 * @param {object} - future relon with pending_from, pending_reln, and/or pending_to_s set. 
 */
 SENDQ.pendingDynamicGhostVarUpdateONLY = async($future_relon, $TXTYPE)=> {
    if (SENDQ.aQ.length==0) {
        console.warn("something is wrong -- we must have a prev cmd in the Q to use pending relons!");
        return;
    }

    //audit the pending to_s
    if ($future_relon.pending_to_s==undefined) {
        console.warn("malformed pending dynamic var.  Pending to_s should be defined.");
        return;
    }
    else $future_relon.to_s=null;   //if the user kills this TX in the queue this will be busted. hmm.
    
    var cmdObj = TXB.makeChildRelonAPICmd($future_relon, $TXTYPE, TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND);
    cmdObj.PENDING_DATA=true;
    return cmdObj;
}


/**
 * Intended to tie a MAKER cmd to children CMDS that use the maker CMD.
 * If the MAKER cmd is removed the children CMDS are null and void.
 * 
 * Called from any of the "pending" CMD Types.
 * @param {*} $cmdObj 
 * @returns 
 */
SENDQ.setPrevAffect = function ($cmdObj) {
    if (SENDQ.aQ.length<=1) {
        console.warn("something is wrong -- we must have a prev cmd!");
        return;
    }
    var prevCmd = SENDQ.aQ[ SENDQ.aQ.length-2];
    if (prevCmd.affect==undefined) prevCmd.affect = [$cmdObj];
    else prevCmd.affect.push($cmdObj);
    return;
}


SENDQ.getCmdByTxid=function($txid) {
    for (var a=0; a < SENDQ.aQ.length; a++) {
        var cmdObj = SENDQ.aQ[a];
        if (cmdObj.relon==undefined) continue;
        if (cmdObj.relon==null) continue;
        if (cmdObj.relon.txid!=$txid) continue;
        return cmdObj;
    }
    return null;
}


/**
 * Add relon to the send Q (through the meta Q).
 * 
 * note: gui_extras comes on the relon.  Get it, and delete that relon prop.
 * 
 * @param {object}
 * @author Mr.Scatman
 */
SENDQ.addRelonToSendQ = async($relon, $bSINGLESEND=true, $TXTYPE=null, $bCallbackSingleSend=null, $bDUPEOK=false)=> {
    if ($relon==null) {
        return null;
    }
    
    var TXTYPE = $TXTYPE;
    var SPECIAL = null;
    var cmdObj = null;

    //no dupes of non-type awareness relons in the queue (prevent user mistkes).
    //there is no reason to dupe a relon that isn't a signal/awareness.
    //keyless inst requests are unnamed and thus could come in valid dupes (they are just creating neurons)
    if ($bDUPEOK==false && $TXTYPE!=TXB.TXTYPE_KEYLESS_NEURON && $relon.type!=TYPE_AWARENESS) {
        var qItem = SENDQ.relonIsAlreadyInQ($relon, $bDUPEOK);
        if (qItem!=null) {
            if (ANNE.SETTINGS.debug()==true) {
                console.log("dupe");
                ANNE.TALK.printRelon($relon);
            }
            return qItem;
        }
    }

    var fromNOBJ = MEMG.getNeuronByTempNid($relon.f);
    var bDOINGSELF = true;

    if (fromNOBJ==null) {
        console.warn("(addRelonToSendQ) error, no fromNOBJ");
        return null;
    }

    //we will need to set the .childwif in the cmdObj.
    if (fromNOBJ.nid != USER._userNObj.nid) bDOINGSELF = false;

    //self-relons will use the seed at runtime to sign the TXs.
    if (bDOINGSELF==true) {
        if (TXTYPE==null) TXTYPE=ANNE.TXB.TXTYPE_SELF_RELON;
        if ($relon.to_type>=TO_TYPE_ENCR_ANNE) {
            SPECIAL=ANNE.TXB.CMD_ENCRYPT_SELF_TO;//ge.encryption_method=
        }
        cmdObj = ANNE.TXB.makeSelfRelonAPICmd($relon, TXTYPE, SPECIAL, "", $bDUPEOK);
    }

    //both key'd and keyless children will come through here.
    //only key'd children will have the MEM.key relon and require the OwnProve process.
    //The own prove processes make it possible for key'd neurons to broadcast their
    //TXs from the identity without having to waste TXs to send funds to the key'd neuron.
    else {
        if (TXTYPE==null) TXTYPE=ANNE.TXB.TXTYPE_CHILD_RELON;
        if ($relon.to_type>=TO_TYPE_ENCR_ANNE) {
            SPECIAL = TXB.CMD_ENCRYPT_CHILD_TO_CMD;
        }
        cmdObj = TXB.makeChildRelonAPICmd($relon, TXTYPE, SPECIAL);
    }

    
    if ($relon.gui_extras!=undefined) {
        cmdObj.gui_extras = $relon.gui_extras;

        if (cmdObj.gui_extras.udf_service_fee!=undefined) {
            TXB.addAnniesToCmd(cmdObj, USER._userNObj.nid, parseInt(cmdObj.gui_extras.udf_service_fee));
            console.warn("adjusted annies for additional service fee");
        }

        //this one can go directly into the cmdObj.. (since we didn't pass it in)
        if ($relon.gui_extras.msg!=undefined) cmdObj.msg = $relon.gui_extras.msg;
        delete $relon.gui_extras;
    }
    
    //console.log(cmdObj);
    
    //display the badge update in the message area, if relevant.
    SENDQ.cartChange();

    //console.log("%c ADDED TO SEND Q %c "+cmdObj.msg, ANNE.TALK.bgred, ANNE.TALK.bggreen);

    //this will use the generic built-in prompt
    if ($bSINGLESEND==true) {
        await SENDQ.___sendQueue($bCallbackSingleSend);
    }

    return cmdObj;
}


/**
 * 
 * @param {*} $txid 
 * @returns 
 */
SENDQ.hasRelonInQueue=function($txid) {
    for (var a=0; a < SENDQ.aQ.length; a++) {
        var cmdObj = SENDQ.aQ[a];
        if (cmdObj.relon==null) continue;
        if (cmdObj.relon.txid==$txid) return true;
    }
    return false;
}


/** 
 * Used to prevent double q sponsors or double button clicks.  
 *       
 * TO DO. make it smart to prevent contradictory ANDY relons for the same thing
 * ie, approving and denying the same request in the same queue.
 */
SENDQ.relonIsAlreadyInQ=function($relon, $bDUPEOK=false) {
    if ($relon==null) return null;
    
    //dupes fine for payment relons when permited.
    if ($bDUPEOK==true) return null;

    var ge = $relon.gui_extras;
    var ref_var = null;
    if (ge!=undefined && ge!=null) {
        if (ge.ref_var!=null) ref_var = ge.ref_var;
    }
    
    for (var q=0; q < SENDQ.aQ.length; q++) {
        var qItem = SENDQ.aQ[q];
        if (qItem.relon!=undefined) {
            var relon = qItem.relon;
            //dupe awareness is ok.
            if (relon.type==TYPE_AWARENESS) continue;
            if (relon.txid==$relon.txid) {
                return qItem;
            }
            if (relon.from_nid!=$relon.from_nid) continue;
            if (relon.type!=$relon.type) continue;
            if (relon.reln!=$relon.reln) continue;
            if (relon.to_type!=$relon.to_type) continue;
            if (relon.to_s!=$relon.to_s) continue;

            //still unique!
            if (ref_var!=null && qItem.gui_extras!=undefined 
                && qItem.gui_extras!=null 
                && qItem.gui_extras.ref_var!=undefined
                && qItem.gui_extras.ref_var!=null 
                && qItem.gui_extras.ref_var!=ref_var) {
                continue;
            }
            
            console.log("already in queue!");
            ANNE.TALK.printRelon(relon);
            return qItem;
        }
    }
    return null;
}


SENDQ.isEmpty = function() {
    if (SENDQ.aQ.length==0) return true;
    return false;
}
SENDQ.hasItems = function() {
    if (SENDQ.aQ.length > 0) return true;
    return false;
}

/**
 */
SENDQ.___sendQueue=async($refreshCallbackTemp=null, $mustRunPreTestFunction=null, $cancelSendCB=null, $failedCB=null)=>{
    if (SENDQ.aQ.length==0) {
        SENDQ.cartChange();  //ensure 0 in ico
        if ($refreshCallbackTemp!=null) $refreshCallbackTemp();
        return;
    }
    SENDQ._bDOINGSEND = true;

    if ($refreshCallbackTemp!=null) {
        if (ANNE.SETTINGS.debug()==true) console.log("%c setting refresh callback temp", TALK.bgpurple);
        SENDQ.__refreshCallbackTemp = $refreshCallbackTemp;
    }
    else {
        if (ANNE.SETTINGS.debug()==true) console.log("%c no callback for upcoming sendq", TALK.bgpurple);
        SENDQ.__refreshCallbackTemp = null;
    }
    if ($mustRunPreTestFunction!=null) SENDQ.__mustRunPreTestFunction = $mustRunPreTestFunction;
    else SENDQ.__mustRunPreTestFunction = $mustRunPreTestFunction;
    var items = SENDQ.aQ.length;
    var plural = TALK.pluralizeNounIf(items, "item", "s");
    var msg = "We are about to process the "+plural+" in your send queue.  We will display the required TXs for your confirmation."; 
    var pObj = new page_params(SENDQ.sendSuccess, $cancelSendCB, $failedCB, msg);
    return await PAGES.openPage("sender", pObj);
}



/**
 * Sometimes a cmd is no longer needed.
 * In particular, a VARS update cmd is no longer needed if we do a collab hanai with the relon we were
 * going to pend (for later) and merely update.
 * 
 * Sometimes a collab relon cannot be made yet and thus it is pended (and key vars updated in memory from the tx sends).
 * It can be sent after the update.
 */
SENDQ.deleteByTXTYPE=function($TXTYPE=TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND, $txid, $reason="") {
    for (var c=0; c < ANNE.SENDQ.aQ.length; c++) {
        var cmdObj = ANNE.SENDQ.aQ[c];
        if (cmdObj.cmds_special!=null && cmdObj.cmds_special.indexOf($TXTYPE)!=-1) {
            if (cmdObj.relon!=undefined && cmdObj.relon!=null && cmdObj.relon.txid==$txid) {
                ANNE.SENDQ.aQ.splice(c,1);
                if (ANNE.SETTINGS.debug()==true) console.log("(deleteByTXTYPE) spliced out %c"+$reason, TALK.bggreen, cmdObj);
                return;
            }
        }
    }
    return;
}


/**
 * 
 */
SENDQ.aduditForTXTYPE=function($nid, $TXTYPE=ANNE.TXB.TXTYPE_KEYLESS_NEURON, $slot="pending_from"){
    for (var c=0; c < ANNE.SENDQ.aQ.length; c++) {
        var cmdObj = ANNE.SENDQ.aQ[c];
        if (cmdObj.TXTYPE==$TXTYPE) {
            if (cmdObj.relon[$slot]!=undefined && cmdObj.relon[$slot]!=null && cmdObj.relon[$slot]=="new_"+$nid) {
                if (ANNE.SETTINGS.debug()==true) console.log("(SENDQ.aduditForTXTYPE) found existing "+cmdObj.relon[$slot]);
                return true;
            }
            else if (cmdObj.relon[$slot]!=undefined && cmdObj.relon[$slot]!=null && cmdObj.relon[$slot]==$nid) {
                if (ANNE.SETTINGS.debug()==true) console.log("(SENDQ.aduditForTXTYPE) found existing "+cmdObj.relon[$slot]);
                return true;
            }
        }
    }
    return false;
}


/**
 * Look for either keyless (generic) or global/global location
 * We want to see if we have the proper make cmd existing in the queue
 */
SENDQ.aduditForMAKER=function($ghost_nid){
    for (var c=0; c < ANNE.SENDQ.aQ.length; c++) {
        var cmdObj = ANNE.SENDQ.aQ[c];
        if (cmdObj.TXTYPE==ANNE.TXB.TXTYPE_KEYLESS_NEURON || cmdObj.TXTYPE==ANNE.TXB.TXTYPE_MAKE_GLOBAL || cmdObj.TXTYPE==ANNE.TXB.TXTYPE_MAKE_GLOBAL_LOCATION) {
            
            //this is a keyless or make global/make global location
            if (cmdObj.znid!=undefined && cmdObj.znid==$ghost_nid) {
                if (ANNE.SETTINGS.debug()==true) console.log("(SENDQ.aduditForMAKER) found znid: "+cmdObj.znid);
                return true;
            }
        }
    }
    return false;
}


/**
 */
SENDQ.sendQueueInstant=async($refreshCallbackTemp=null)=>{

    SENDQ.__refreshCallbackTemp = $refreshCallbackTemp;

    var rez = await TXB.sender(ANNE.SENDQ.aQ);
    
    if (rez==false || typeof rez!="object" || rez.status!="success") {
        //save/fix/update what we can, if anything, then fail this send. :(
        SENDQ._bDOINGSEND = false;
        USER.updateLastBalance(); //for the global wallet helper.
        SENDQ.aQ = [];
        TXB._totalAnniesThisSession += TXB._metaQ.totalAnnies;
        SENDQ._metaQ = {};
        TXB._metaQ=null;
        await ANNE.___masterTXSuccessProcessor(rez, null);
        return SENDER.failed(rez);
    }
    else {
        SENDQ.sendSuccess(rez, true);
    }
    return;
}


/**
 * hide q gui from the screen in the DOM.
 */
SENDQ.hideQ = function() {
    if (SENDQ._divid_q!="") {
        ANNE.A.hide(SENDQ._divid_q);
        SENDQ._bSENDQISOPEN = false;
    }
}



//***********************  DELETES AND CLEANUPS OF Q ITEMS ***************//
SENDQ.dupeQEntry = function ($tempCmdObj) {
    if (ANNE.SETTINGS.debug()==true) {
        console.log("this was a dupe entry in your queue");
        console.log($tempCmdObj);
    }
}



//VANILLA INTERFACE TO UDF (USER DEFINED) FUNCTIONS (located in local folder send_queue_udf.js)
//inteface functions have 3 (___) undescores and attempt to call their counterpart
//in a _udf.js function.

/**
 */
SENDQ.cartChange =  function() {
    //ext to do, put cart_badge on ico.
    if (SENDQ.aQ.length==0) SENDQ.hideQ();
    return;
}


/**
 */
SENDQ.resetQgui = function() {
    if (SENDQ.aQ.length) SENDQ.___genQgui();
    else {
        ANNE.A.setHTML(SENDQ._divid_q+"_msg","");
        ANNE.A.setHTML(SENDQ._divid_q+"_btn", "no items in send queue");
        SENDQ.cartChange(0);
        SENDQ.hideQ();
    }
}


/**
 */
SENDQ.clearAll = async($bGOBACK=false)=> {
    SENDQ.aQ = [];
    SENDQ._metaQ = {};
    TXB._metaQ=null;
    SENDQ.cartChange(0);
    if ($bGOBACK==true && ANNE.PAGES!=null) ANNE.PAGES.historyGoBack($e);
}


/**
 */
SENDQ.sendSuccess=async($rez, $bNOGUI=false)=> {  
    SENDQ._bDOINGSEND = false;
    if (ANNE.SETTINGS.debug()==true) {
        console.log("(SENDQ.sendSuccess)"); 
        console.log($rez);
    }
    ANNE.A.hide("loading");
    USER.updateLastBalance(); //for the global wallet helper.
    SENDQ.aQ = [];
    if ($bNOGUI==false) SENDQ.resetQgui();
    TXB._totalAnniesThisSession += TXB._metaQ.totalAnnies;
    SENDQ._metaQ = {};
    TXB._metaQ=null;
    
    //hand off control to the masterTXSuccessProcessor interface function.
    await ANNE.___masterTXSuccessProcessor($rez, SENDQ.__refreshCallbackTemp);
    return;
}


/**
 * TO DO -- if the Q send fails after some succeed.. clean up what did and didnt send
 */
SENDQ._cleanupPartialQ = async()=> {
    var deletedItems=0;
    for (var q=0; q < SENDQ.aQ.length; q++) {
        var tempObj = SENDQ.aQ[q];
        if (tempObj.txid!=undefined) {
            SENDQ.aQ.splice(q, 1);
            q--;
            deletedItems+=1;
        }
    }
    if (deletedItems) SENDQ.cartChange();
    SENDQ.___genQgui();
}


/**
 */
SENDQ.___sendFailed = async($results)=> {
    console.warn("(___sendFailed) ANNE queue send failed", $results);
    ANNE.A.hide(SENDQ._divid_q+"_btn");

    //do what we can here... so process whatever we had done up to this point.
    await ANNE.___masterTXSuccessProcessor($results, null);

    //SENDQ._bREGENNEEDED = true;
    //SENDQ.aQ = [];
    //TXB._metaQ = null;
    return;
}


/**
 */
SENDQ.___overview=function() {
    var btnDiv = document.getElementById(SENDQ._divid_q+"_btn");
    if (btnDiv==null) return;
    alert("IS THIS USED?");
    if (SENDQ.aQ.length) {
        var btnmsg = '<i class="ai-paper-plane"></i>&nbsp; Send '+SENDQ.aQ.length+' '+plural;
        btnDiv.innerHTML= btnmsg;
        ANNE.A.show(btnDiv);
        var plural = TALK.pluralizeNounIf(SENDQ.aQ, "item", "s");
        var sendq_cartcnt = document.querySelector(".sendq-cartcnt");
        if (sendq_cartcnt==null) {
            alert("element sendq-cartcnt is missing from the DOM");
            return;
        }
        sendq_cartcnt.innerHTML = SENDQ.aQ.length+" "+plural;
    }
    else {
        ANNE.A.hide(btnDiv);
        var sendq_cartcnt = document.querySelector(".sendq-cartcnt");
        if (sendq_cartcnt==null) {
            alert("element sendq-cartcnt is missing from the DOM");
            return;
        }
        sendq_cartcnt.innerHTML =  "no items";
        return;
    }
    
    var btnDiv = document.getElementById(SENDQ._divid_q+"_btn");
    var btnmsg = '<i class="ai-paper-plane ai"></i>&nbsp; Send '+SENDQ.aQ.length+' '+plural;
    btnDiv.innerHTML=btnmsg;
}


/**
 */
SENDQ.___genQgui =  function() {
    if (SENDQ._divid_q=="") return;
    var msgDiv = ANNE.A.empty(SENDQ._divid_q+"_msg");
    if (msgDiv==null) return;

    SENDQ.___overview();
    
    if (SENDQ.aQ.length==0) {
        ANNE.A.hide(SENDQ._divid_q);
        SENDQ._bSENDQISOPEN=false;
        TXB._metaQ = null;
        return;
    }
    else {
        ANNE.A.show(SENDQ._divid_q);
        SENDQ._bSENDQISOPEN=true;
    }

    var alert_class = "alert-sendq-pending";
    var ico = "";

    //ALL MSG SETTING WAS HANDLED IN THE TX_BUILDER.
    for (var q=0; q < SENDQ.aQ.length; q++) {
        var msg = "";
        var cmdObj = SENDQ.aQ[q];
        if (cmdObj.cmdguid==undefined) {
            console.warn("malformed cmdObj");
            continue;
        }
        if (cmdObj.msg!=undefined && cmdObj.msg!="") msg = cmdObj.msg;         
        if (cmdObj.relon!=undefined) {
            if (msg=="" && cmdObj.relon!=undefined && cmdObj.relon.msg!=undefined) {
                msg = cmdObj.relon.msg;
            }
            var fromNOBJ = MEMG.getNeuronByTempNid(relon.f);

            //upgrading ghost data to real data.
            if (cmdObj.relon.ghost==true) {
                if (ANNE.isANNE(fromNOBJ.owned_by)==true) ico = "ghost-upgrade-to-ANNE";
                else if (fromNOBJ.owned_by==USER._userNObj.nid) ico = "ghost-upgrade-to-mine";
                else ico = "ghost-upgrade-to-other";
            }
        }
        TALK.makeSendQAlert(msgDiv, alert_class, ico, msg, "q_alert_"+cmdObj.cmdguid, SENDQ.deleteQItemByClick);
    }
}