class send_funds_gui {
    constructor() {
        this.el_msg = null;
        this.el_recipient = null;
        this.el_save_recipient = null;
        this.btn_send = null;
        this.chk_include_msg = null;
        this.chk_encrypted = null;
        this.encrypt_msg = false;
        this.has_msg = false;
        this.el_recap = null;
        this.amt_to_sendANNIES = 0;
        this.recipient = "";
        this.max_sendANNIES = 0;
        this.recipientPublicKey = "";
        this.triedIt = [];
        this.bONBOARDING=false;
        this.msg = "";
        this.ENCRYPT_DEACTIVE = false;
        this.broadcastSelfRelon=false;
        this.misc = null;
        this.bPUBKEYEVENTMADE = false; //make it once.
    }

    init = async($pObj)=> {
        this.amt_to_sendANNIES = 0;
        this.recipient = "";
        this.max_sendANNIES = 0;
        this.recipientPublicKey = "";
        this.encrypt_msg = false;
        this.has_msg = false;
        this.triedIt = [];
        this.bONBOARDING=false;
        this.msg = "";
        this.ENCRYPT_DEACTIVE = false;
        this.broadcastSelfRelon=false;
        this.misc = null;

        this.balanceObj = await USER.getOurBalance();
        await ANNE.ANNEID.BALANCE_FIXER.getUpdatedBalance2("sf_available_now", "sf_available_soon",);
        
        this.max_sendANNIES = this.balanceObj.avail_now_annies;
        this.max_sendANNECOIN = (this.max_sendANNIES/100)-1;     //min fee is 1, so this is the most.
        
        if (ANNE.SETTINGS.debug()==true) console.log("max send annies:"+ANNE.UTILS.commas(this.max_sendANNIES));

        ANNE.TALK.printBalanceObj(this.balanceObj);

        this.btn_send = document.getElementById("btn_sf_send");
        this.btn_send.addEventListener("click", this.sendFunds);

        this.btn_max = document.getElementById("btn_sf_max");
        this.btn_max.addEventListener("click", async e=>{
            this.el_amount.value = this.balanceObj.annecoin-1;
            ANNE.A.hide(this.btn_max);
            await this.amountChanged(null, this.el_amount);
            //if message, minus more.
            //if encrypted, minus even more.
        });

        this.chk_include_msg = document.getElementById("sf_chk_include_msg");
        this.chk_include_msg.addEventListener("change", this.msgChkChg);
        this.el_msg = document.getElementById("sf_msg_div");
        this.el_msg.addEventListener("input", this.msgChanged);
        ANNE.A.hide(this.el_msg);

        this.chk_encrypted= document.getElementById("sf_chk_encrypted");
        this.chk_encrypted.addEventListener("change", this.encryptedChkChg);
        
        this.el_recap = document.getElementById("sf_recap_and_confirm");

        this.el_amount = document.getElementById("sf_amount");
        this.el_amount.addEventListener("input", this.amountChanged);
        this.el_amount.setAttribute("el_display", "sf_amount");
        this.el_amount.setAttribute("el_submit", "btn_sf_send");
        this.el_amount.setAttribute("min_val", 1);
        this.el_amount.setAttribute("max_val", this.max_sendANNECOIN);
        this.el_recipient = document.getElementById("sf_recipient");
        this.el_recipient.addEventListener("change", this.recipientChanged);
        this.el_save_recipient = document.getElementById("btn_sf_save");
        this.el_save_recipient.addEventListener("click", e=>this.saveRecipient(e));
        ANNE.A.hideParent(this.el_save_recipient);

        const THIS = this;
        this.btn_pubkey_address = document.getElementById("btn_sf_sendby_pubkey");
        this.btn_pubkey_address.addEventListener("click", e=>{
            ANNE.A.show("div_pubkey_address");
            ANNE.A.hide(this.btn_pubkey_address);
            const pubkeyinput2 = document.getElementById("sf_input_pubkey2");
            pubkeyinput2.addEventListener("input", e=>{
                var pubkey = pubkeyinput2.value;
                var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(pubkey);
                if (addressObj!=null) {
                    console.log(addressObj);
                    this.bONBOARDING=true;
                    this.recipientPublicKey = pubkey;
                    this.recipient = addressObj._numericId;
                    ANNE.A.setValue("sf_recipient", this.recipient);
                }
                else {
                    this.bONBOARDING=false;
                    this.recipientPublicKey = "";
                }
                THIS.recipientChanged(null, true);
            })
        })

        var outs = USER._userNObj.outs;
        this.masterDDObjs = [];

        //rememberz
        for (var r=0; r<outs.length;r++){
            if (outs[r].type!=TYPE_AWARENESS) continue;
            if (outs[r].r!=MEM.rememberz.temp_nid) continue;
            var remNOBJ = MEMG.getNeuronByTempNid(outs[r].t);
            this.masterDDObjs.push( {type:"rememberz", nObj:remNOBJ, nick:remNOBJ.bestNameHTML()} );
        }

        //local prefs
        var prefs = ANNE.SETTINGS.getAllPrefsByClass("local_fav_acct");
        for (var p=0; p<prefs.length; p++){
            var prefAcctNOBJ = MEMG.getNeuronByNid(prefs[p].value_misc);
            if (prefAcctNOBJ==null) continue;
            this.masterDDObjs.push( {type:"local save", nObj:prefAcctNOBJ, nick:prefs[p].lbl} );
        }

        //local user accts on this machine (multi-accts)
        for (var a=0; a < ANNE._userAccts.length; a++) {
            var acctObj = ANNE._userAccts[a];
            if (acctObj.nid==USER._userNObj.nid) continue;
            var nOBJ = MEMG.getOrMakeIfNew(acctObj.nid);
            var name = "";
            if (acctObj.text=="" || acctObj.text==nOBJ.nid) name = nOBJ.bestNameHTML();
            else name = acctObj.text;
            this.masterDDObjs.push( {type:"user accts", nObj:nOBJ, nick:name} );
        }

        var default_fund_to_nid = null;
        if ($pObj && $pObj.misc) {
            default_fund_to_nid = $pObj.misc.default_fund_to_nid;
            var nObj = MEMG.getNeuronByNid(default_fund_to_nid);
            if(nObj.ghost==false) {
                var name = nObj.bestNameHTML();
                this.masterDDObjs.push({type:"ext accts", nObj:nObj, nick:name});
            }
            this.misc = $pObj.misc;
        }

        ANNE.A.ezDD_masterDDObj("sf_ez_access", this.masterDDObjs, this.localFavsSelected, "select from saved", true, "", true);   
        if (default_fund_to_nid!=null) {
            ANNE.A.setValue(this.el_recipient, default_fund_to_nid);
            this.recipientChanged(null, true);
        }

        if ($pObj && $pObj.misc && $pObj.misc.annies) {
            ANNE.A.setValue(this.el_amount, $pObj.misc.annies/ANNE.ANNE_TO_ANNIES);
            var an = $pObj.misc.annies+"";
            var an_last = an[ an.length-1];
            this.amountChanged({data:an_last});//emulate data part of the event.
        }
    }


    /**
     */
    localFavsSelected = async($e)=> {
        var nid = ANNE.A.getValue('sf_ez_access');
        if (nid!=null && nid>0) {
            ANNE.A.setValue(this.el_recipient, nid);
        }
        await this.recipientChanged($e, false);
    }


    /**
     * Check rememberz and local saved array.
     * If not in it, open up the local save.
     */
    notSaved=function($nid) {
        for (var s=0; s < this.masterDDObjs.length; s++) {
            if (this.masterDDObjs[s].nObj.nid==$nid) return false;
        }
        return true;
    }


    /**
     */
    recipientChanged = async($e, $bTEST=true)=> {
        ANNE.A.empty("sf_result");
        this.recipient = ANNE.A.getValue(this.el_recipient);
        if (this.recipient=="") {
            ANNE.A.hideParent(this.el_save_recipient);
            return;
        }

        var recipient_NOBJ = ANNE.MEMG.getNeuronByNid(this.recipient);
        if (recipient_NOBJ==null) {
            //lookup in API.
            await ANNE.API.getNeuronByNid(this.recipient, [0,1,2,3], true);
            recipient_NOBJ = ANNE.MEMG.getNeuronByNid(this.recipient);
            if (recipient_NOBJ==null) return;
        }

        //if sending to a keyless neuron there is NO MSG or ENCRYPT available.
        if (recipient_NOBJ.origin==ORIGIN_KEYLESS) {
            this.ENCRYPT_DEACTIVE=true;
            ANNE.A.hide(this.chk_encrypted);
            this.encrypt_msg = false;
            this.broadcastSelfRelon=true;
            ANNE.A.hide(this.chk_include_msg);
            ANNE.A.hide(this.el_msg);
            this.has_msg=false;                
            this.msg = "";
        }

        else {
            this.ENCRYPT_DEACTIVE=false;
            ANNE.A.show(this.chk_encrypted);
            this.broadcastSelfRelon=false;
        }

        await this.recap();

        if ($bTEST==false || this.recipient=="") {
            ANNE.A.hideParent(this.el_save_recipient);
            return;    
        }
        if (this.notSaved(this.recipient)==true) {
            ANNE.A.showParent(this.el_save_recipient);
        }
        else ANNE.A.hideParent(this.el_save_recipient);
    }


    /**
     */
    thisIsRememberz=function($nid) {
        for (var s=0; s < this.masterDDObjs.length; s++) {
            if (this.masterDDObjs[s].type!="rememberz") continue;
            if (this.masterDDObjs[s].nObj.nid==$nid) return true;
        }
        return false;
    }


    /**
     * Store a local record of this recipient
     */
    saveRecipient = async($e)=>{
        ANNE.A.hideParent($e.target);
        var save_lbl = ANNE.A.getValue("sf_save_name");
        await ANNE.SETTINGS.setPref(this.recipient, "local_fav_acct", save_lbl);
        var prefAcctNOBJ = MEMG.getNeuronByNid(this.recipient);
        this.masterDDObjs.push( {type:"local save", nObj:prefAcctNOBJ, nick:save_lbl} );
    }



    /**
     * 
     * @param {*} $e 
     */
    amountChanged=async($e, $target=null)=>{
        await ANNE.A.anne_entered($e, $target);
        this.amt_to_sendANNIES = parseInt(this.el_amount.value)*100;
        
        if (this.amt_to_sendANNIES<0 || ANNE.UTILS.isset(this.amt_to_sendANNIES)==false) {
            this.amt_to_sendANNIES = 0;
            ANNE.A.setValue(this.el_amount, 0);
        }
        
        //ANNE.A.setValue(this.el_amount, this.amt_to_sendANNIES);
        await this.recap();
    }


    /**
     * 
     * @param {*} $e 
     */
    msgChkChg=async($e)=>{
        if (this.chk_include_msg.checked==true) {
            ANNE.A.show(this.el_msg);
            this.has_msg=true;                
            this.msg = ANNE.A.getValue("sf_msg");    //re-instate an old val if they typed it and hid the check.
        }
        else {
            ANNE.A.hide(this.el_msg);
            this.has_msg=false;
            this.msg = "";       
        }

        //ensure we have the encrypted check value set right too.
        if (this.chk_encrypted.checked==true) {
            this.encrypt_msg = true;
        }
        else this.encrypt_msg = false;
        
        await this.recap();
    }


    /**
     * 
     * @param {*} $ 
     */
    msgChanged=async($)=>{
        this.msg = ANNE.A.getValue("sf_msg");
        await this.recap();
    }

    /**
     * 
     * @param {*} $e 
     */
    encryptedChkChg=async($e)=>{
        if (this.chk_encrypted.checked==true) {
            this.encrypt_msg = true;
        }
        else this.encrypt_msg=false;
        await this.recap();
    }


    /**
     * validate send, show errors, if good, open up send btn
     */
    recap=async()=> {
        ANNE.A.empty(this.el_recap);
        var pubKeyLocal = "";
        var issues = [];
        var nObj =null;

        var THIS = this;

        var displayIssues=function() {
            ANNE.A.setHTML(THIS.el_recap, issues.join(" "));
            THIS.el_recap.classList = "center";
            THIS.el_recap.classList.add("recap-errors");
            ANNE.A.hide("sf_btn_div");
            return;
        }
        
        if (this.recipient=="") {
            issues.push("Recipient missing.");
            return displayIssues();
        }
        else if (this.recipient[0]=="z") {
            issues.push("CAN'T SEND TO THIS ADDRESS! IT IS A TEMP ADDRESS. THIS SHOULD NEVER HAPPEN!");
            return displayIssues();
        }
        else if (this.has_msg==true && this.msg.length==0) {
            issues.push("If you check the has message you must provide a message.  Uncheck it if you do not want to send a message.");
            return displayIssues();
        }
        else if (this.amt_to_sendANNIES==0) {
            issues.push("Amount missing.");
            return displayIssues();
        }
        else if (this.amt_to_sendANNIES > this.max_sendANNIES) {
            issues.push("Amount ("+ANNE.UTILS.commas(this.amt_to_sendANNIES)+") > balance ("+ANNE.UTILS.commas(this.max_sendANNIES)+").");
            return displayIssues();
        }

        nObj = MEMG.getOrMakeIfNew(this.recipient);
        

        //for sends to a keyless acct.
        if (this.broadcastSelfRelon==true) {
            this.bONBOARDING=false;
            this.recipientPublicKey = "";
        }

        //for sends to real accts
        else {
            //this pubKey is set onchain.
            if (nObj.pubKey!=undefined && nObj.pubKey!=null && nObj.pubKey!="") {
                this.bONBOARDING=false;
                this.recipientPublicKey = nObj.pubKey;
            }   
            
            //no pub key in RAM.  Let's investigate.
            else {
                //look it up in ANNE.
                if (this.triedIt.indexOf(this.recipient)==-1) {
                    await ANNE.API.getAccountPublicKey(this.recipient);
                    this.triedIt.push(this.recipient);
                }
                
                if (nObj.pubKey!=undefined && nObj.pubKey!=null && nObj.pubKey!="") {
                    this.bONBOARDING=false;
                    this.recipientPublicKey = nObj.pubKey;
                } 

                //no known key so far, check our local RAM accts.
                else {

                    pubKeyLocal = ANNEID.pubKeyFromKnownAcct(this.recipient);
                    if (pubKeyLocal==null || pubKeyLocal=="") {
                        pubKeyLocal = ANNE.A.getValue("sf_input_pubkey").trim();
                        if (pubKeyLocal==undefined || pubKeyLocal==null || pubKeyLocal=="") {
                            pubKeyLocal="";
                            ANNE.A.show("sf_mpk");
                            
                            if (this.bPUBKEYEVENTMADE==false) {
                                var input_mpk = ANNE.A.__getEl("sf_input_pubkey");
                                input_mpk.addEventListener("input", e=>{
                                    console.log("key typed");
                                    
                                    //we're good to go.
                                    if (ANNE.USER.auditAcctIdFromPubKey(this.recipient, input_mpk.value)==true) {
                                        this.bONBOARDING=true;
                                        this.recipientPublicKey = input_mpk.value;
                                        ANNE.A.hide("sf_mpk");
                                        console.log("key is good");
                                        issues = [];
                                    }
                                    else {
                                        issues.push("not a valid public key for anne acct id "+this.recipient);
                                    }
                                });
                                this.bPUBKEYEVENTMADE=true;
                            }
                            
                            if (this.recipientPublicKey!=null && this.recipientPublicKey.length>20) {
                                console.log("manual entered (address from key method)");
                                this.bONBOARDING=true;
                                 pubKeyLocal=this.recipientPublicKey;
                                ANNE.A.hide("sf_mpk");
                            }
                            else issues.push("cannot send transaction.  There is no known publicKey on chain or in your local user accounts for this recipient.  Please provide public key.");
                            if (issues.length>0) return displayIssues();
                        }
                        else {
                            this.bONBOARDING=true;
                            this.recipientPublicKey = pubKeyLocal;
                        }
                    }

                    //confirmed, onboarding TX!
                    else {
                        this.bONBOARDING=true;
                        this.recipientPublicKey = pubKeyLocal;
                    }
                }
            }
        }


        if (nObj!=null) {
            nObj.disambigIDHTMLStr("sf_disambig", true, true);
        }

        if (issues.length) {
            ANNE.A.setHTML(this.el_recap, issues.join(" "));
            this.el_recap.classList = "center";
            this.el_recap.classList.add("recap-errors");
            ANNE.A.hide("sf_btn_div");
            return;
        }

        else {
            this.el_recap.classList = "center";
            this.el_recap.classList.add("recap-good");
            
            var actionMsg = "send <b>"+ANNE.UTILS.commas(this.amt_to_sendANNIES/ANNE.ANNE_TO_ANNIES)+"</b> annecoin to "+this.recipient;

            if (this.bONBOARDING==true) {
                actionMsg = actionMsg+"<br>ONBOARDING pubKey "+this.recipientPublicKey+" with this transaction.";
                if (this.has_msg==true) {
                    var msg = ANNE.A.getValue("sf_msg");
                    if (this.encrypt_msg==true) {
                        actionMsg = actionMsg+"<br>will encrypt and send message of "+this.msg+" that only "+this.recipient+" can decrypt";
                    }
                    else actionMsg = actionMsg+"<br>sending non-ecrypted message of "+this.msg;
                }
            }

            else if (this.has_msg==true) {
                if (this.encrypt_msg==true) {
                actionMsg = actionMsg+"<br>Will encrypt and send message of <b>"+this.msg+"</b> that only "+this.recipient+" can decrypt.";
                }
                else actionMsg = actionMsg+"<br>Sending non-ecrypted plain text message of <b>"+this.msg+"</b>.";
            }
            
            ANNE.A.setHTML(this.el_recap, actionMsg);
            ANNE.A.show("sf_btn_div");
        }
    }


    /**
     * Send funds with the SendAnne API ANNODE function if the acct is real or being onboarded.
     * 
     * Do a relon send if the acct is a keyless neuron.
     * @param {*} $e 
     * @returns 
     */
    sendFunds=async($e)=>{
        ANNE.A.hide("sf_btn_div");
        var result = null;

        if (this.broadcastSelfRelon==true) {

            //we want the TX_BUILDER handling of ghsot mem and error handling
            var newPaymentRelon = MEMZ.ez_new_sys_msg(USER._userNObj, MEM.annies.nid, TO_TYPE_ANNE, this.recipient, {payment:this.amt_to_sendANNIES, annies_offset:-400}, 
                async(e)=>{
                    ANNE.playSound('annies_spent');
                    ANNE.A.setValue(this.el_amount, "");
                    this.amt_to_sendANNIES = 0;
                    this.broadcastSelfRelon = false;
                    this.recipient = "";
                    ANNE.A.setValue(this.el_recipient, "");
                    ANNE.A.empty(this.el_msg, true);
                    ANNE.A.empty("sf_disambig", true);

                    console.log("this should fix the balance.");
                    
                    await ANNE.ANNEID.BALANCE_FIXER.getUpdatedBalance2("sf_available_now", "sf_available_soon");

                    if (this.misc!=null && this.misc.callback!=undefined) {
                        if (this.misc.callbackParams!=undefined) {
                            this.misc.callback(...this.misc.callbackParams);
                        }
                        else this.misc.callback();
                        this.misc=null;
                    }
                });

            ANNE.playSound("success");
            ANNE.SENDQ.___sendQueue();
            return;
        }
        
        //sendAnne with a message
        //TODO:  shouldn't this fail due to wrong fee????
        else if (this.has_msg==true && this.msg.length) {
            if (this.encrypt_msg==true) {
                var aO = USER.prepANNEAuthObjFromSeed(USER.seedObj.seed);
                if (aO==null) {
                    ANNE.A.setHTML(this.el_recap, "problem extracting key from memory.  Can't encrypt message.");
                    return;
                }
                var eObj = await ANNE.USER.encryptMsgForPUBKEY(this.msg, this.recipientPublicKey, aO.priv_key, true);
                var edata = ANNE.SIGNA.util.convertByteArrayToHexString(eObj.data);
                var enonce = ANNE.SIGNA.util.convertByteArrayToHexString(eObj.nonce);
                result = await ANNE.API.sendAnne(this.recipient, this.recipientPublicKey, this.amt_to_sendANNIES, ANNE.ANNE_TO_ANNIES, 1440, "", true, edata, enonce);
            }
            else {
                result = await ANNE.API.sendAnne(this.recipient, this.recipientPublicKey, this.amt_to_sendANNIES, ANNE.ANNE_TO_ANNIES, 1440, this.msg, false);
            }
        }

        //if no message and no onboarding, do not send the recipientPubKey.
        else {

            //simple send (already known pubKey) to user with funds.
            if (this.bONBOARDING==false) {
                this.recipientPublicKey="";
                result = await ANNE.API.sendAnne(this.recipient, "", this.amt_to_sendANNIES, ANNE.ANNE_TO_ANNIES);
            }
            else {
                if (this.recipientPublicKey==null || (this.recipientPublicKey=="")) {
                    console.log("this is trouble.  We need the pubKey to onboard and send funds. This is acct is unknown.");
                    alert("fix ur code, Mrscatman.  We shouldn't get here.");
                    return;
                }

                //onboaring TX with funds + no message.
                result = await ANNE.API.sendAnne(this.recipient, this.recipientPublicKey, this.amt_to_sendANNIES, ANNE.ANNE_TO_ANNIES);
            }
        }
        
        ANNE.A.setJSON('sf_result', result);
        if (result && result.status=="bad") {
            ANNE.A.setHTML(this.el_recap, "transaction failed.");
            this.el_recap.classList = "center";
            this.el_recap.classList.add("recap-errors");
            ANNE.playSound('annies_spent');

            //make a relon for the send?
        }
        else {
            ANNE.playSound('annies_spent');
        }
        ANNE.A.show("sf_result");

        //submit TX and publish results here.
        ANNE.A.setValue(this.el_amount, "");

        this.amt_to_sendANNIES = 0;
        this.broadcastSelfRelon = false;
        this.recipient = "";

        ANNE.A.setValue(this.el_recipient, "");
        ANNE.A.empty(this.el_msg, true);
        ANNE.A.empty("sf_disambig", true);

        await ANNE.ANNEID.BALANCE_FIXER.getUpdatedBalance2("sf_available_now", "sf_available_soon",);
    }
}


//kind of irrelevant now with SEND_FUNDS..
//as we must ensure garbage collection of events from use to use ..
//thus instantiate gui for mods we keep around. arrrg.
var SEND_FUNDS = {};

/**
 */
SEND_FUNDS.init=async($pObj)=> {
    var sfgui = new send_funds_gui();
    await sfgui.init($pObj);
}
