
/**
 * 
 * TODO:
 * 
 * @author {Mr.Scatman}
 */ 
class service_genprop extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.makeclass_nObj = MEM._GENERAL_PROP_CLASS;
        this.el_input.addEventListener("input",  e=>this.inputEventHandler_genprop_typed(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress_genprop(e, this)); 
        this.el_checkbtn.addEventListener("click", e=>this.testNew_genProp(e));

        //this.el_dd = document.getElementById("dd_actions_"+this.ID);
        this.el_ss = document.getElementById("ss_div_"+this.ID);

        var bSMARTSEARCH = true;
        var bTESTFORNEW = false;
        var bLVLSMODE = true;
        this._SS = new smart_search(this.el_ss, this.ID, MEM._GENERAL_PROP_CLASS.temp_nid, bSMARTSEARCH, "select action parent", bTESTFORNEW, bLVLSMODE);
        
        var tnids = [];
        var bINSTS = false;
        MEM._GENERAL_PROP_CLASS.getAllDownlineChildren(tnids, 0, bINSTS, true, false, false);
        var finaltnids = [];
        for (var t=0; t < tnids.length; t++) {
            var nOBJ = MEMG.getNeuronByTempNid(tnids[t]);
            if (nOBJ.ntype == NTYPE_INST) continue;
            finaltnids.push(nOBJ.temp_nid);
        }

        if (finaltnids.indexOf(MEM._GENERAL_PROP_CLASS.temp_nid)==-1) {
            finaltnids.push(MEM._GENERAL_PROP_CLASS.temp_nid);
        }

        this._SS.init_dd_vals(finaltnids, true, true);
        this._SS.onValid = this.validGenpropSelected;     //a valid neuron selection the SS has been made
        this._SS.onInValid = this.invalidGenPropSelection; //no valid selection in the SS made
        this._SS.newCallback = null;
        this._SS.searchCallback=this.searchForGenProp;

        this._SS.setDefaultValue(MEM._GENERAL_PROP_CLASS.text);
        this._SS.hideSearch();

        //set default to GEN PROP CLASS.
        this.validGenpropSelected(MEM._GENERAL_PROP_CLASS);
        this.el_input.focus();
        
        //keyup event for ss too!
        this._SS.el_ss.addEventListener("keyup", e=>this.returnKeyPress_genprop(e, this));
        this.enter="lookup";
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewGenprop(e));
    }


    /**
     * 
     * @param {*} $nObj 
     */
    validGenpropSelected = async($nObj)=> {
        console.log("validActionSelected");
        this.makeclass_nObj = $nObj;
        this.classNid = $nObj.nid;
        var el_parentcd = ANNE.A.empty("parent_class_disambig");
        var disambigEl = ANNE.A.ezEl(el_parentcd, "div", "");
        this.makeclass_nObj.disambigHTMLStr(disambigEl, true, true, "selected parent class &nbsp;");
        var el_bes =  ANNE.A.ezEl(disambigEl, "div", "simple-row");
        ANNE.MEMZ.ezNeuronBes(el_bes, this.makeclass_nObj, LINKS_NEURON_DOSSIER);
        ANNE.PAGES.updateLastHistMiscProp("generalprop_selected_nid", this.makeclass_nObj.nid);  //we can deep link load this on a back
    }
    


    /**
     * 
     * @param {*} $val 
     * @param {*} $bool 
     * @param {*} $newResults 
     */
    invalidGenPropSelection = async($val, $bool, $newResults=-1)=> {
        this.classNid = MEM._GENERAL_PROP_CLASS.nid;
        this.makeclass_nObj = MEM._GENERAL_PROP_CLASS;
        var el_parentcd = ANNE.A.empty("parent_class_disambig");
        el_parentcd.innerHTML = "invalid parent class selection";
    }

    

    /**
     * 
     * @param {*} $e 
     */
    searchForGenProp = async($e)=>{
        var searchVal  = this._SS.getVal();
        var aMatches = await CHASE.anne_bem_search(searchVal, this.makeclass_nObj.temp_nid, [MEM.ANNE_ACCTID, USER._userNObj.nid]);
        console.log(aMatches);
        if (aMatches==undefined) return;
        if (aMatches==null) return;
        if (aMatches.length==0) return;
        
        var tnids=[];
        if (aMatches.length) {
            for (var a=0; a < aMatches.length; a++) {
                var match = aMatches[a];
                if (match==undefined) continue;
                if (match==null) continue;
                
                if (tnids.indexOf(aMatches[a].temp_nid)==-1) tnids.push(aMatches[a].temp_nid) 
            }
            
            this._SS.redoDD(tnids);
            var el_avcol1 = ANNE.A.empty("avcol1_"+this.ID);
            ANNE.A.ezEl(el_avcol1, "div", "simple-row", "<span class='text-success-lbl'>"+tnids.length+"</span> possible matches found");
            ANNE.A.show(this.el_recapdiv);
            this._SS.el_ss.focus();
        }
    }


    /**
     * Test for this new property.  We don't want dupe properties.
     * @param {*} $e 
     */
    testNew_genProp = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var newGenPropVal = this.el_input.value;
        var be_nids = [this.classNid];
        if (be_nids.indexOf(this.makeclass_nObj.nid)==-1) be_nids.push(this.makeclass_nObj.nid);

        var searchObj = ANNE.SEARCH.SS.getDefaultSearchObj(newGenPropVal, be_nids);
        searchObj.exact = true;

        var aMatches = await CHASE.anne_global_search(searchObj);
        console.log(aMatches);
        if (aMatches.length==0) {
            var txt = ANNE.A.getValue(this.el_input);
            this.el_msg.innerHTML="<span class='text-success-lbl'>new '"+txt+"' gen prop available</span>";
            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
        }
        else {
            ANNE.A.empty(this.el_msg);
            var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
            EXT_BTNS.makeNeuronLink(el, aMatches[0].nid);
            ANNE.A.hide("confirm_new_div");
            el.append("already exists");
            ANNE.A.hide(this.el_saveghostbtn);
            this.enter = "lookup";
        }
    }


    /**
     * 
     * @param {*} $e 
     * @param {*} $this 
     * @returns 
     */
    returnKeyPress_genprop = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") {
                if (MEM.makeclass_nObj==null) $this.searchForGenProp(null); 
                else $this.testNew_genProp($e);
            }
            else if ($this.enter=="submit") {
                $this.makeNewGenprop($e);
            }
        }
    }


    /**
     * Gen prop will be subclassing whatever the makeclass is.
     * Makeclass with default as GENPROP but can be set to any subclass of GENPROP
     * @param {*} $e 
     */
    makeNewGenprop = async($e)=> {
        var txt = ANNE.A.getValue(this.el_input);
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(this.makeclass_nObj, txt, NTYPE_CLASS);
        PAGES.launchNeuron(ghostNOBJ.nid);
    }


    /**
     * 
     * @param {*} $e 
     */
    inputEventHandler_genprop_typed=async($e)=> {
        ANNE.A.hide(this.el_savebtn);
        ANNE.A.hide(this.el_saveghostbtn);
        ANNE.A.empty(this.el_msg);
        
        var txt = ANNE.A.getValue(this.el_input);
        if (txt.length>1) {
            ANNE.A.setHTML(this.el_checkbtn, " check availability", true);
            this.enter = "lookup";
            ANNE.A.show("confirm_new_div");
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            this.enter= "none";
            ANNE.A.hide("confirm_new_div");
        }
    }
}
