const LINKS_NEURON_MODAL = 1;            //quick neuron summary page
const LINKS_NEURON_EMBED = 2;            //full neuron summary page
const LINKS_NEURON_DS = 3;               //data-source view of neuron's BE dimension
const LINKS_NEURON_TBL_VIEW = 4;         //table view of neuron's relons
const LINKS_NEURON_TREE = 5;             //tree view of a neuron's BE dimension
const LINKS_NEURON_ANNET = 6;            //graph explore of neurons
const LINKS_NEURON_ANDY = 7;             //ADMIN AREA
const LINKS_NEURON_ALEXANNDRIA = 8;      //library of your neurons  (can also find others)

const LINKS_NEURON_USER = 10;            //user profile page.
const LINKS_NEURON_INJECT_CB = 11;       //injection link w/ callback
const LINKS_NEURON_BLOCKCHAIN = 12;      //a link to the 3d viewer of blockchain data.
const LINKS_NEURON_DOSSIER = 14;         //detailed dossier view
const LINKS_NEURON_BRAIN = 16;           //decide if rememberz/forgetz is on/off
const LINKS_NEURON_ANNULET_OF_TRUST = 17;

const LINKS_RELON_ANNE = 20;             //an ANNE relon of somekind.
const LINKS_TX_BLOCKEXPLORER = 21;       //not an ANNE relon, a standard blockchain TX

var EXT_BTNS = {};
EXT_BTNS.bINIT = false;
EXT_BTNS.btn_class = "header-btn";
EXT_BTNS.btnsendQ  = null;
EXT_BTNS.btn_header_ghosts = null;


EXT_BTNS.clicked = function($page) {
    if (ANNE.PAGES!=null) ANNE.PAGES.openPage($page);
}


/**
 */
EXT_BTNS.unlocked = function() {
    ANNE.MEM_UDF.unlocked();
}


//todo, review this queue thingie showing up (if needed?)
EXT_BTNS.showHideQBtn = function() {
    return;
}


/**
 * @author {Mr.Scatman}
 */
 EXT_BTNS.doStandardIcoLinks=function($el, $nObj, $types, $white=true) { 
    var el = ANNE.A.__getEl($el);
    for (var t=0; t<$types.length; t++) {
        var type = $types[t];
        EXT_BTNS.makeIcoLinkByType(type, el, $nObj.nid);//, type, {display:$display});
    }
}


EXT_BTNS.icoClicked=async($e, $page, $nid)=> {
    console.log("ico clicked for page:"+$page);
    PAGES.openPage($page, new page_params(null, null, null, $nid));
}


/**
 * @author {Mr.Scatman}
 */
 EXT_BTNS.makeIcoLinkByType=function($linkType, $el, $nid) {
    var title = "";
    var span=document.createElement("span");
    //span.href="";
    span.classList.add("dib");
        
    var nObj = MEMG.getNeuronByNid($nid);
    if (nObj==null) return;
    
    //works in EXT now
    if ($linkType==LINKS_NEURON_DOSSIER) {
        var ico=GUI_STUFF.getIco("DOSSIER"); //openDSTBL
        span.innerHTML=ico;
        span.title="Dossier view";
        span.addEventListener("click", e=>EXT_BTNS.icoClicked(e, 'dossier', nObj.nid));
        $el.append(span);
    }


    else if ($linkType==LINKS_NEURON_DS) {
        var ico=GUI_STUFF.getIco("DS"); //openDSTBL
        //span.addEventListener("click", e=>PAGES.openPage("DSTBL", new page_params(null, null, null, nObj.temp_nid)));
        span.innerHTML=ico;
        span.title="𝄐 DataSrc view (COMING SOON)";
        $el.append(span);
        span.classList.add("disabled");
    }


    //neuron tree ico link
    else if ($linkType==LINKS_NEURON_TREE) {
        var ico=GUI_STUFF.getIco("TREE");
        //span.href="javascript:LINKS.openTree('"+$nObj.temp_nid+"')";
        span.title="Tree view (COMING SOON)";
        span.innerHTML=ico;
        span.classList.add("dib");
        $el.append(span);
        span.classList.add("disabled");
    }
    
    //annet graph ico link
    else if ($linkType==LINKS_NEURON_ANNET) {
        var ico=GUI_STUFF.getIco("ANNET");
        span.innerHTML=ico;
        span.title="ANNET graph viewer";
        span.addEventListener("click", (e)=>{ANNE.PAGES.openANNET(nObj.temp_nid);});
        span.classList.add("dib");
        $el.append(span);
    }

    else if ($linkType==LINKS_NEURON_ANDY) {
        var ico=GUI_STUFF.getIco("ANDY");
        span.innerHTML=ico;
        span.title="Administration of ANNE neurons (COMING SOON)";
        span.classList.add("dib");
        $el.append(span);
        span.classList.add("disabled");
    }
    
    else if ($linkType==LINKS_NEURON_ALEXANNDRIA) {
        var ico=GUI_STUFF.getIco("ALEXANNDRIA");
        span.addEventListener("click", e=>PAGES.openPage("alexanndria", new page_params(null, null, null, nObj.temp_nid)));
        span.innerHTML=ico;
        span.title="the mother of all libraries (COMING SOON)";
        $el.append(span);
        span.classList.add("disabled");
    }
    
    else if ($linkType==LINKS_NEURON_BRAIN) {
        var title = "";
        var icoclass = "";
        if (nObj.rememberz!=undefined) {
            title="forgetz this neuron";
            icoclass = "brain-on";
        }
        else {
            title="rememberz this neuron";
            icoclass="brain-off";
        }
        var ico=GUI_STUFF.getIco("REMEMBERZ", 22, "smart_"+nObj.temp_nid+" img-ico "+icoclass);
        span.addEventListener("click", e=>ANNE.toggleBrain(nObj.temp_nid));
        span.innerHTML=ico;
        span.title = title;
        span.classList.add("dib");
        $el.append(span);
    }
}


EXT_BTNS.makeNeuronLinkFromNeuronArr=function($el, $tnids, $class="", $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier", $sqpre="") {
    if ($el==null) {
        console.log("missing el");
        return;
    }
    var el = ANNE.A.__getEl($el);
    if (el==null) {
        console.log("missing el");
        return;
    }
    if ($tnids==undefined || $tnids==null || $tnids.length==0) return;
    if ($pre!="") {
        var spanpre=document.createElement("span");
        spanpre.innerHTML=$pre;
        el.append(spanpre);
    }
    for (var a=0; a < $tnids.length; a++) {
        var nObj = null;
        if (($tnids[a] instanceof anne_neuron)==true) {
            nObj = $tnids[a];
        }
        nObj = MEMG.getNeuronByTempNid($tnids[a]);    
        
        var span=document.createElement("span");
        span.classList="btn-launch";
        //EXT_BTNS.classifySpanBtn(nObj, span);
        var classtxt = EXT_BTNS.classifySpanBtn(nObj, span, $sqpre);
        
        ANNE.MEM_UDF.fireNeuron(nObj, .2);
        if ($class!="") span.classList.add($class);
        
        if ($txtoverride!="") span.innerHTML = "&#x25A0;"+$txtoverride;
        else span.innerHTML = "&#x25A0;&nbsp;"+nObj.bestNameHTML();
        
        span.setAttribute("nid", nObj.nid);
        span.addEventListener("click", e=>ANNE.PAGES.launchNeuron(nObj.nid));
        el.append(span);
    }

    if($page==null || $page==undefined || typeof $page!="string") $page="";
    span.setAttribute("page", $page);
    if ($bADDCOPY) ANNE.A.addCopyIco(el, $nid);
}

/**
 * Default page (link type) is dossier view.
 * pass a valid page type to alter the link being created.
 */
 EXT_BTNS.makeNeuronLinkFromRelonArr=function($el, $arr, $class="", $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier") {
    if ($el==null) {
        console.log("missing el");
        return;
    }
    var el = ANNE.A.__getEl($el);
    if (el==null) {
        console.log("missing el");
        return;
    }
    
    if($arr==undefined || $arr==null || $arr.length==0) return;

    if ($pre!="") {
        var spanpre=document.createElement("span");
        spanpre.innerHTML=$pre;
        el.append(spanpre);
    }
    
    //loop the arr 
    for (var a=0; a < $arr.length; a++) {
        var rel = $arr[a];
        var text = MEMG.__MASTER_DISPLAY_RELON_TO(rel);
        var nObj = null;
        if (rel.to_type==TO_TYPE_ANNE) {
            nObj = MEMG.getNeuronByTempNid(rel.t);
            var span=document.createElement("span");
            span.classList="btn-launch";
            EXT_BTNS.classifySpanBtn(nObj, span);
            ANNE.MEM_UDF.fireNeuron(nObj, .2);
            if ($class!="") span.classList.add($class);
            if ($txtoverride!="") span.innerHTML = "&#x25A0;"+$txtoverride;
            else span.innerHTML = "&#x25A0;&nbsp;"+text;
            
            span.setAttribute("nid", nObj.nid);
            span.addEventListener("click", e=>PAGES.launchNeuron(nObj.nid));
            el.append(span);
        }
        else {
            var span=document.createElement("span");
            if ($class!="") span.classList.add($class);
            if ($txtoverride!="") span.innerHTML = $txtoverride;
            else span.innerHTML = text;
            span.title = "non-neuron text";
            el.append(span);
        }
    }

    if($page==null || $page==undefined || typeof $page!="string") $page="";
    span.setAttribute("page", $page);
    if ($bADDCOPY) ANNE.A.addCopyIco(el, $nid);
}


/**
 * Here we want to launch and view a clump -- via another role.
 * We are not launching the role, but the clump it is linked to.
 */
 EXT_BTNS.makeClumpLinkFromRelonArr=function($el, $arr, $clump_nid=0, $callback=null) {
    if ($el==null) return;
    var el = ANNE.A.__getEl($el);
    if (el==null) return;
    if($arr==undefined || $arr==null || $arr.length==0) return;
    for (var a=0; a < $arr.length; a++) {
        var roleROBJ = $arr[a];
        var text = MEMG.__MASTER_DISPLAY_RELON_TO(roleROBJ);
        var span=document.createElement("span");
        span.classList="btn-launch clump-launch";
        span.innerHTML = "&#x25A0;&nbsp;"+text;
        span.title = "view clump";
        span.setAttribute("clump-nid", $clump_nid);
        span.addEventListener("click", e=>$callback($clump_nid));
        el.append(span);
    }
}

/**
 */
EXT_BTNS.makeEditClumpLink=function($el, $clumpNOBJ, $callback=null, $textOverride="") {
    if ($el==null) return;
    var el = ANNE.A.__getEl($el);
    if (el==null) return;
    var span=document.createElement("span");
    span.classList="btn-launch clump-launch";
    span.style["font-style"]='italic';
    var text = $textOverride;
    if (text=="") text = $clumpNOBj.text;
    if ($clumpNOBJ.ghost==true) {
        span.innerHTML = '<img class="dib" src="../imgs/ghost_ico.png" width="12px" title="Ghost (local neuron).">&nbsp;'+text;
        span.title = "edit/view ghost (local) clump";
    }
    else {
        span.innerHTML = "&#x25A0;&nbsp;"+text;
        span.title = "edit/view clump";
    }
    span.setAttribute("clump-nid", $clumpNOBJ.nid); 
    span.addEventListener("click", e=>$callback($clumpNOBJ.nid));
    el.append(span);
}


/**
 * User this one!!
 */
EXT_BTNS.injectRelonForm=async($relon, $relnNid, $injectElid)=> {
    var el = ANNE.A.show($injectElid);
    el.innerHTML="this is where the injection div will go!";
    ANNE.A.smartScroll($injectElid);
}

/**
 * 
 * @param {anne_neuron} $nObj 
 * @param {Element} $span 
 * @param {String} $classpre - a sq- or [something]- to alter the class so it displays differently but uses the same name 
 * @returns 
 */
EXT_BTNS.classifySpanBtn=function($nObj, $span=null, $classpre="") {
    if ($nObj==null) {
        alert("classfySpanBtn FIX THIS. Should never be null");
        return "";
    }

    if ($nObj.freeze==1) {
        if ($span!=null) {
            $span.classList.add($classpre+"froze-neuron");
            $span.title = "froze neuron "+$nObj.nid;
        }
        return $classpre+" froze-neuron";
    }

    else if ($nObj.pending_merge!=undefined) {
        if ($span!=null) {
            $span.classList.add($classpre+"pending-merge-neuron");
            $span.title = "pending merge "+$nObj.nid;
        }
        return $classpre+" pending-merge-neuron";
    }

    else if ($nObj.ghost==true) {
        if ($span!=null) {
            $span.classList.add($classpre+"ghost-neuron");
            $span.title = "your ghost "+$nObj.nid;
        }
        return $classpre+" ghost-neuron";
    }

    else if ($nObj.owned_by=="") {
        if ($span!=null) {
            $span.classList.add($classpre+"anne-wv");
            $span.title = "ANNE's neuron "+$nObj.nid;
        }
        return $classpre+"anne-wv";
    }

    else if ($nObj.owned_by==USER._userNObj.nid || $nObj.nid==USER._userNObj.nid) {
        if (ANNE.isANNE(USER._userNObj.nid)==true) {
            if ($span!=null) {
                $span.classList.add($classpre+"anne-wv");
                $span.title = "ANNE owned "+$nObj.nid;
            }
            return $classpre+"anne-wv";
        }

        if ($nObj.nid==USER._userNObj.nid) {
            if ($span!=null) {
                $span.classList.add($classpre+"mine");
                $span.title = "your identity "+$nObj.nid;
            }
            return $classpre+"mine";
        }

        else {
            var pending_hanai = ANNE.HANAI.getPendingHanai($nObj);
            if (pending_hanai!=null) {
                if ($span!=null) $span.classList.add($classpre+"pending-hanai");
                if ($span!=null) $span.title = "pending hanai "+$nObj.nid;
                return $classpre+"pending-hanai";
            }
            else {
                if ($span!=null) $span.classList.add($classpre+"mine");
                if ($span!=null) $span.title = "your owned neuron "+$nObj.nid;
                return $classpre+"mine";
            }
        }
    }


    else if ($nObj.owned_by==MEM.ANNE_ACCTID) {
        if ($nObj.sponsored_by==USER._userNObj.nid) {
            if ($span!=null) {
                $span.classList.add($classpre+"me-sponsor");
                $span.title = "your sponsored neuron "+$nObj.nid;
            }
            return $classpre+"me-sponsor";
        }

        if ($span!=null) {
            $span.classList.add($classpre+"anne-wv");
            $span.title = "view ANNE neuron "+$nObj.nid;
        } 
        return $classpre+"anne-wv";
    }


    else {
        if ($span!=null) {
            if (MEM.isIdentity($nObj)==true) {
                $span.classList.add($classpre+"identity-neuron");
                $span.title = "view identity neuron "+$nObj.nid;
            }
            else {
                $span.classList.add($classpre+"other-neuron");
                $span.title = "view other neuron "+$nObj.nid;
            }
        }
        return $classpre+"other-neuron "+$nObj.nid;
    }
    return "";
}


EXT_BTNS.makeAnyElNeuronLaunch=function($el, $nid) {
    if ($el==undefined) {
        console.log("%c (makeAnyElNeuronLaunch) fix this donkey kong", TALK.bgredbig);
        return;
    }

    $el.addEventListener("click", e=>{
        ANNE.playSound("beep");
        PAGES.launchNeuron($nid);
    });
}





/**
 * Default page (link type) is dossier view.
 * pass a valid page type to alter the link being created.
 */
 EXT_BTNS.makeNeuronLink=function($el, $nid, $class="",  $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier", $classpre="") {
    if (($nid instanceof anne_neuron) == true) {
        $nid=$nid.nid; //derp fix this.
    }
    if ($nid==undefined || $nid==null) return;
    if ($el==null) {
        console.log("missing el");
        return null;
    }
    var el = ANNE.A.__getEl($el);
    if (el==null) {
        console.log("missing el");
        return null;
    }
    if ($pre!="") {
        var spanpre=document.createElement("span");
        spanpre.innerHTML=$pre;
        el.append(spanpre);
    }
    var span=document.createElement("span");
    span.classList="btn-launch";
    var nObj = MEMG.getOrMakeIfNew($nid);
    EXT_BTNS.classifySpanBtn(nObj, span, $classpre);
    ANNE.MEM_UDF.fireNeuron(nObj, .2);
    if ($class!="") span.classList.add($class);
    var ico = "&#x25A7;";
    if (ANNE.isANNE(nObj.owned_by)==true || nObj.owned_by=="") ico = "&#x25A0;";
    
    //ico override
    ico = EXT_BTNS.doBestIco(nObj, ico);

    if ($txtoverride!="") span.innerHTML = ico+$txtoverride;
    else span.innerHTML = ico+nObj.bestNameHTML();
     
    span.setAttribute("nid", $nid);
    span.addEventListener("click", e=>{
        ANNE.PAGES.launchNeuron($nid, $page, e);
    });
    el.append(span);
    if($page==null || $page==undefined || typeof $page!="string") $page="";
    span.setAttribute("page", $page);
    if ($bADDCOPY) ANNE.A.addCopyIco(el, $nid);
    return span;
}

/**
 * Default page (link type) is dossier view.
 * pass a valid page type to alter the link being created.
 */
 EXT_BTNS.makeNeuronLink_colorSquares=function($el, $nid, $class="", $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier", $sqpre="sq-", $maxlen=128) {
    if($nid==undefined || $nid=="") return null;
    if ($el==null) {
        console.log("missing el");
        return null;
    }
    var el = ANNE.A.__getEl($el);
    if (el==null) {
        console.log("missing el");
        return null;
    }

    if ($pre!="") {
        var spanpre=document.createElement("span");
        spanpre.innerHTML=$pre;
        el.append(spanpre);
    }
    var span=document.createElement("span");
    span.classList="btn-launch";
    var nObj = MEMG.getOrMakeIfNew($nid);
    var classtxt = EXT_BTNS.classifySpanBtn(nObj, null, $sqpre);
    ANNE.MEM_UDF.fireNeuron(nObj, .2);
    var icotxt = "&#x25A7;";
    if (ANNE.isANNE(nObj.owned_by)==true) icotxt = "&#x25A0;";

    icotxt = EXT_BTNS.doBestIco(nObj, icotxt);

    var nm = $txtoverride;
    if (nm=="") nm = nObj.bestNameHTML();
    if (nm.length>$maxlen) {
        nm = nm.substring(0, $maxlen-1)+"...";
    }

    ANNE.A.ezEl(span, "span", classtxt+" dib", icotxt+nm);
    span.setAttribute("nid", $nid);
    span.addEventListener("click", e=>{
        PAGES.launchNeuron($nid, $page, e);
    });
    el.append(span);
    if($page==null || $page==undefined || typeof $page!="string") $page="";
    span.setAttribute("page", $page);
    if ($bADDCOPY) ANNE.A.addCopyIco(el, $nid);
    return span;
}


/**
 * 
 * @param {*} $nObj 
 * @param {*} $icotxt 
 * @returns 
 */
EXT_BTNS.doBestIco=function($nObj, $icotxt="") {
    if (ANNE.SETTINGS && ANNE.SETTINGS.bUICOS==false) return "";
    
    var icotxt = $icotxt;
    if ($nObj._uico!=undefined) {
        icotxt = $nObj._uico;
    }
    else {
        var parentCLASS = MEMG.getNeuronByTempNid($nObj.bes[0]);
        if (parentCLASS && parentCLASS._uico!=undefined) {
            icotxt = parentCLASS._uico;
        }
    }
    return icotxt;
}


/**
 * 
 * @param {*} $el 
 * @param {*} $nid 
 * @param {*} $class 
 * @param {*} $pre 
 * @param {*} $bADDCOPY 
 * @param {*} $txtoverride 
 * @param {*} $page 
 * @returns 
 */
EXT_BTNS.makeNeuronALink=function($el, $nid, $class="", $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier") {
    if ($pre!="") {
        var spanpre=document.createElement("span");
        spanpre.innerHTML=$pre;
        $el.append(spanpre);
    }
    var atag=document.createElement("a");
    atag.classList="neuron-launch";
    atag.href="";
    var nObj = MEMG.getOrMakeIfNew($nid);
    if ($class!="") atag.classList.add($class);
    if (nObj.owned_by==MEM.ANNE_ACCTID) atag.classList.add("anne-wv-hoveronly");
    if ($txtoverride!="") atag.innerHTML = $txtoverride;
    else atag.innerHTML = nObj.bestNameHTML();
    atag.title = "view neuron";
    atag.setAttribute("nid", $nid);
    atag.addEventListener("click", e=>PAGES.launchHrefNeuron(e));
    if($page==null || $page==undefined || typeof $page!="string") $page="";
    $el.append(atag);
    if ($bADDCOPY) ANNE.A.addCopyIco($el, $nid);
    return atag;
}

EXT_BTNS.makeRelonViewLinkWithPre_SMART=function($pre, $el, $relon, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="") {
    var el =  ANNE.A.__getEl($el);
    if (el==null) return;
    var span = document.createElement("span");
    el.append(span);
    if ($pre && $pre.length>0) span.innerHTML = $pre;
    EXT_BTNS.makeRelonViewLink_SMART(el, $relon, false, $h, $imgOnly, $relonClass);
    span.style['cursor']="pointer"
    return span;
}

EXT_BTNS.getRelonLinkIco=function($relon, $h=12){
    if ($relon==null || $relon=="") {
        console.log("(getRelonLinkIco) no relon");
        return "";
    }
    
    if ($relon!=null && $relon.ghost==true) {
        return '<img src="../imgs/ghost_txid.png" style="display:inline-block" alt="" class="" height="'+$h+'">';
    }
    else if ($relon!=null && ($relon.andy_rel!=undefined || $relon.isAndyRel!=undefined)
        && ($relon.time==0 || $relon.time==undefined) 
        && $relon.status_text!="a") {
        return '<img src="../imgs/andy_txid.png" style="display:inline-block" alt="" class="" height="'+$h+'">';
    }
    return '<img src="../imgs/txid.png" txid="'+$relon.txid+'" style="display:inline-block" alt="" class="" height="'+$h+'">';
}


/**
 * 
 * @param {Element} $el 
 * @param {Object} $relon 
 * @param {Boolean} $bEMPTY 
 * @param {int} $h 
 * @param {Boolean} $imgOnly 
 * @param {String} $relonClass 
 * @param {String} $txtoverride 
 * @returns 
 */
EXT_BTNS.makeRelonViewLink_SMART=function($el, $relon, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="", $txtoverride="") {
    if ($relon==undefined || $relon==null) {
        console.log("REALLY????");
        return;
    }
    if ($bEMPTY==true) ANNE.A.empty($el);
    var andyAdmin =false;
    var span = document.createElement("span");
    span.classList="btn-launch relon-launch";
    if ($relonClass!="") span.classList.add($relonClass);
    $el.append(span);

    var img = EXT_BTNS.getRelonLinkIco($relon, $h);
    
    //this will trigger andy features in the gui relon_view
    //gui hackers can obv turn this on.. but it will just lose funds by broadcasting
    //bad TXs to the ANNODE.  We can't refund bad TXs since that would be a threat vector.
    //We take the fee and do not add any actionable relons to the hypergraph.
    if ($relon.andy_rel!=undefined || $relon.isAndyRel!=undefined) andyAdmin=true;

    if ($imgOnly==true && $txtoverride=="") span.innerHTML = img;
    else if ($txtoverride!="") span.innerHTML = img+$txtoverride;
    else span.innerHTML = img+$relon.txid;
    span.title = "view hypergraph relon "+$relon.txid+" height:"+$relon.time;
    if(andyAdmin==true) span.setAttribute("andy", 1);
    span.setAttribute("txid", $relon.txid);
    span.addEventListener("click", e=>EXT_BTNS.launchRelon(e));
    return span;
}


EXT_BTNS.makeRawTXLink=function($el, $txid, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="", $txtoverride="") {
    if ($bEMPTY==true) ANNE.A.empty($el);
    var span = document.createElement("span");
    span.classList="btn-launch relon-launch";
    if ($relonClass!="") span.classList.add($relonClass);
    $el.append(span);
    var img = '<img src="../imgs/txid.png" txid="'+$txid+'" style="display:inline-block" alt="" class="" height="'+$h+'">';
    if ($imgOnly==true && $txtoverride=="") span.innerHTML = img;
    else if ($txtoverride!="") span.innerHTML = img+$txtoverride;
    else span.innerHTML = img+$txid;
    span.title = "view raw TX";
    span.setAttribute("txid", $txid);
    span.addEventListener("click", e=>EXT_BTNS.launchRelon(e));
    return span;
}


EXT_BTNS.launchRelon=async($e)=>{
    var btn = ANNE.A.getFirstParentOf($e.target,"relon-launch",true);
    if (btn==null) {
        console.log("ut oh!");
        return;
    }
    var txid=btn.getAttribute("txid");
    var andyAdmin=btn.getAttribute("andy");
    var page=btn.getAttribute("page");
    if (page==undefined || page==null) page = "";
    return ANNE.PAGES.launchRelon(txid, andyAdmin, page);
}

//deprecate the non-smart func
EXT_BTNS.makeRelonViewLinkWithPre=function($pre, $el, $txid, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="") {
    var el =  ANNE.A.__getEl($el);
    if (el==null) return;
    var span = document.createElement("span");
    el.append(span);
    if ($pre && $pre.length>0) span.innerHTML = $pre;
    EXT_BTNS.makeRelonViewLink(el, $txid, false, $h, $imgOnly, $relonClass);
    span.style['cursor']="pointer"
    return span;
}

//deprecate the non-smart func
EXT_BTNS.makeRelonViewLink=function($el, $txid, $bEMPTY=true, $h=8, $imgOnly=false, $relonClass="", $txtoverride="") {
    var relon = MEMG.lookupRelonByTXID($txid);
    
    //backup method if no relon is found in local MEM
    //we will chase it if the user clicks on it.
    if (relon==null) {
        //console.log("skipping txid:"+$txid+" for relon link");
        var span=document.createElement("span");
        span.classList="btn-launch relon-launch";
        span.title = "view hypergraph relon "+$txid;
        span.setAttribute("txid", $txid);
        var img='<img src="../imgs/txid.png" txid="'+$txid+'" style="display:inline-block" alt="" class="" height="'+$h+'">';
        if ($imgOnly==true) span.innerHTML = img;
        else span.innerHTML = img+$txid;
        span.addEventListener("click", e=>PAGES.launchRelon($txid, false));
        if ($relonClass!="") span.classList.add($relonClass);
        $el.append(span);
        return span;
    }
    
    return EXT_BTNS.makeRelonViewLink_SMART($el, relon, $bEMPTY, $h, $imgOnly, $relonClass, $txtoverride);
}


EXT_BTNS.doGhostSpan=function($el, $w) {
    var ico='<img class="dib" src="../imgs/ghost_ico.png" width="'+$w+'px" title="Ghost (local neuron).">';
    var span = ANNE.A.ezSpan($el, "", "ghostbgwhite", ico);
    return span;
}


EXT_BTNS.doDeleteIco=function($el, $w, $attrs, $click=null, $title="delete") {
    var ico='&#9746;';
    var span = ANNE.A.ezSpan($el, "", "hoverableX", ico);
    var keys = Object.keys($attrs);
    for (var k=0; k < keys.length; k++) {
        var key = keys[k];
        span.setAttribute(key, $attrs[ key ]);
    }
    if ($click!=null) {
        span.addEventListener("click", e=>$click(e));
    }
    return span;
}




/**
 */
EXT_BTNS.getSenderBtnMsg=function($nObj, $size="120", $msg="upgrade your ghost", $class="ghost-upgrade") {
    var ico = "";
    if (ANNE.isANNE($nObj.owned_by)==false) {
        if ($nObj.owned_by==USER._userNObj.nid) ico = GUI_STUFF.getIco("ghost-upgrade-to-mine", $size, $class);
        else ico = GUI_STUFF.getIco("ghost-upgrade-to-other", $size, "ghost-upgrade");
    }
    else ico = GUI_STUFF.getIco("ghost-upgrade-to-ANNE", $size, "ghost-upgrade");
    return ico+"<span style='margin-left: 6px;'>"+$msg+"</span>";
}

EXT_BTNS.getMineBtnMsg=function($size="120", $msg="upgrade your ghost", $class="ghost-upgrade"){
    var ico = GUI_STUFF.getIco("ghost-upgrade-to-mine", $size, $class);
    return ico+"<span style='margin-left: 6px;'>"+$msg+"</span>";
}
