//rename this file anne_paginator.js for Pete's sake.

//just starting this one.. we need it.
class paginator {
    constructor ($parent, $pgui, $guid, $dataArray, $renderCallback, $shard=20) {
        this.pgui = $pgui;
        this.guid = $guid;      //yes, this is also on pgui._guid
        this.ALL_DATA = $dataArray;
        this.data = this.ALL_DATA.concat();
        this.shard = $shard;
        this.bNOTNEEDED = false;
        this.active_page_index = 0;
        this.parent=$parent;
        this.renderCallback = $renderCallback;

        //hmm.. altering this to PAGINATOR_INST (will see if i bust something.)
        //i now need $pgui.INST retained for the original value!
        if ($pgui!=null) $pgui.PAGINATOR_INST = this; //back ref to the paginator.. 
    }

    
    /**
     * Build data array from active records
     */
    renderActiveResults = function() {
        ANNE.A.empty(this._el);
        ANNE.A.removeSelf(this._el);
        this.active_page_index = 0;
        this._el=null;
        this.data = [];
        
        for (var d=0; d < this.ALL_DATA.length; d++) {
            if (this.ALL_DATA[d].active==true) {
                this.data.push(this.ALL_DATA[d]);
            }
        }
        
        this.render();
    }


    /**
     * Render data records
     */
    render = function($el_total=null) {
        var totalresults = this.data.length;
        
        if ($el_total!=null) this.el_total = $el_total;

        //if (this.el_total!=null) this.el_total.innerHTML = totalresults +" total";
        
        if (totalresults <= this.shard) {
            this.bNOTNEEDED = true;
            if (this.renderCallback!=null) return this.renderCallback(this.pgui, this.data);
        }

        this.bNOTNEEDED=false;
        this.pagesNeeded = Math.ceil(totalresults/this.shard);
        this._el = ANNE.A.ezEl(this.parent, "div", "anne-paginator");
        if (this.guid!=null) this._el.setAttribute("guid", this.guid);   //incase we lose our "this"
        
        this.active_page_index = 0;
        var this_paginator = this;
        var maxPages = 10;

        var pgL = ANNE.A.ezEl(this._el, "div", "paginator-btn-sides", "<span class='ai-angle-double-left'></span>");
        pgL.setAttribute("dir", "first");
        //pg.style.display="none";

        var pg2L = ANNE.A.ezEl(this._el, "div", "paginator-btn-sides", "<span class='ai-angle-left'></span>");
        pg2L.setAttribute("dir", "prev");
        //pg2.style.display="none";
        
        var pgs = Math.min(maxPages, this.pagesNeeded);

        for (var p=0; p < pgs; p++) {
            var pg = ANNE.A.ezEl(this._el, "div", "paginator-btn", p+1);
            pg.setAttribute("page_i", p);
            if (p==0) pg.classList.add("active");

            pg.addEventListener("click", $e=>{
                var pg = $e.target;
                var thispaginatorel = ANNE.A.getFirstParentOf(pg, "anne-paginator");
                ANNE.A.removeAddClassOfAllIn(thispaginatorel, ".paginator-btn", "active", pg);

                var page_index = parseInt(pg.getAttribute("page_i"));
                if (page_index == this_paginator.active_page_index) return [];

                var moving = "down";
                if (page_index>this_paginator.active_page_index) moving="up";
                var start_index = (this_paginator.shard*page_index);
                var pagedata = this_paginator.data.slice(start_index, start_index+this_paginator.shard);
                
                //shift buttons..
                //we must pass the right el in case we have multiple instances
                //of this onscreen.
                this_paginator.active_page_index = page_index;

                this_paginator.fixBtns(thispaginatorel, this_paginator.active_page_index, this_paginator.pagesNeeded, moving);

                if (this_paginator.renderCallback!=null) this_paginator.renderCallback(this_paginator.pgui, pagedata);
            });
        }

        var pgR = ANNE.A.ezEl(this._el, "div", "paginator-btn-sides", "<span class='ai-angle-right'></span>");
        pgR.setAttribute("dir", "next"); 

        var pg2R = ANNE.A.ezEl(this._el, "div", "paginator-btn-sides", "<span class='ai-angle-double-right'></span>");
        pg2R.setAttribute("dir", "last");

        if (this.pagesNeeded < 10) {
            pgR.style.display="none";
            pg2R.style.display="none";

            pgL.style.display="none";
            pg2L.style.display="none";
        }
       
        var btns = this._el.querySelectorAll(".paginator-btn-sides");
        for (var b=0; b < btns.length; b++) {
            btns[b].addEventListener("click", $e=>{
                var btn = $e.target;
                if (btn.classList.contains("paginator-btn-sides")==false) btn = btn.parentElement;
                var thispaginatorel = ANNE.A.getFirstParentOf(btn, "anne-paginator");
                var page_index = this_paginator.active_page_index;
                var dir = btn.getAttribute("dir");
                if (dir=="first")page_index = 0;
                else if (dir=="prev") page_index = page_index-1;
                else if (dir=="next") page_index = page_index+1;
                else if (dir=="last") page_index = this_paginator.pagesNeeded-1;
            
                var moving = "down";
                if (page_index>this_paginator.active_page_index) moving="up";

                var start_index = (this_paginator.shard*page_index);
                var pagedata = this_paginator.data.slice(start_index, start_index+this_paginator.shard);
                
                this_paginator.active_page_index = page_index;
                this_paginator.fixBtns(thispaginatorel, this_paginator.active_page_index, this_paginator.pagesNeeded, moving);

                var pagedata = this_paginator.data.slice(start_index, start_index+this_paginator.shard);
        
                if (this_paginator.renderCallback!=null) this_paginator.renderCallback(this_paginator.pgui, pagedata);
            });
        }


        var start_index = (this_paginator.shard*0);
        var pagedata = this_paginator.data.slice(start_index, start_index+this_paginator.shard);

        this.fixTotals(0);

        if (this.renderCallback!=null) this.renderCallback(this.pgui, pagedata);
    }

    fixTotals=function($activeIndex) {
        if (this.el_total!=null) {
            var start = parseInt($activeIndex*(this.shard))+1;
            var end = start+parseInt(this.shard)-1;
            this.el_total.innerHTML= this.data.length+" total &nbsp;<span class='lbl-rows-showing'>(showing&nbsp;"+start+"&nbsp;-&nbsp;"+end+")</span>";
        }
    }

    fixBtns  = function($el, $activeIndex, $pagesNeeded, $moving="up") {
        var btns = $el.querySelectorAll(".paginator-btn-sides");
        if (btns.length!=4) console.warn("btns "+btns.length+" should be 4!!!");
        var firstBtn = btns[0];
        var prevBtn = btns[1];
        var nextBtn = btns[2];
        var endBtn = btns[3];
        //console.log("%c(fixBtns) pages needed:"+$pagesNeeded, TALK.bgpurple);

        this.fixTotals($activeIndex);

        if ($pagesNeeded > 10) {
            var btns = $el.querySelectorAll(".paginator-btn");

            //5 left, 4 to the right.
            //try to center our page in the paginator at all times.
            if ($activeIndex > 0) {
                //console.log("%c(fixBtns) activeIndex:"+$activeIndex, TALK.bgpurple);

                if (($pagesNeeded-$activeIndex) <4) {       //close to end (right)
                    ANNE.A.addClass(endBtn, "disabled");
                    ANNE.A.addClass(nextBtn, "disabled");
                    ANNE.A.removeClass(firstBtn, "disabled");
                    ANNE.A.removeClass(prevBtn, "disabled");

                    //base offset from the right...
                    var offset = $pagesNeeded-($activeIndex+1);

                    for (var b=0; b < btns.length; b++) {
                        var newpage = ($pagesNeeded-1)-9+(b);
                        console.log("newpage:"+newpage);
                        btns[b].setAttribute("page_i", newpage);
                        btns[b].innerHTML = newpage+1;
                        if (newpage!=$activeIndex) btns[b].classList.remove("active");
                        else btns[b].classList.add("active");
                    }
                }

                //do nothing.
                else if ($activeIndex<=4) {
                    return;
                }

                else {
                    ANNE.A.removeClass(endBtn, "disabled");
                    ANNE.A.removeClass(nextBtn, "disabled");
                    ANNE.A.removeClass(firstBtn, "disabled");
                    ANNE.A.removeClass(prevBtn, "disabled");
                    
                    var minOffset = Math.max($activeIndex-4, 0);
                    if ((minOffset+10) > this.pagesNeeded)  {
                        minOffset -= (minOffset+10)-(this.pagesNeeded);
                    }

                    for (var b=0; b < btns.length; b++) {
                        var newpage = minOffset+(b);
                        //console.log("newpage:"+newpage);
                        btns[b].setAttribute("page_i", newpage);
                        btns[b].innerHTML = newpage+1;
                        btns[b].classList.remove("active");
                        if (newpage!=$activeIndex) btns[b].classList.remove("active");
                        else btns[b].classList.add("active");
                    }
                }
            }

            //reset standard position.
            else {
                ANNE.A.removeClass(endBtn, "disabled");
                ANNE.A.removeClass(nextBtn, "disabled");
                ANNE.A.addClass(firstBtn, "disabled");
                ANNE.A.addClass(prevBtn, "disabled");
                

                for (var b=0; b < btns.length; b++) {
                    var newpage = b;
                    btns[b].setAttribute("page_i", newpage);
                    btns[b].innerHTML = newpage+1;
                    btns[b].classList.remove("active");
                    if (newpage!=$activeIndex) btns[b].classList.remove("active");
                    else btns[b].classList.add("active");
                }
            }
        }

        //paginator was needed by the extra << < and > >> buttons were not since
        //we had less than 10 pages of results.
        else {
            ANNE.A.addClass(endBtn, "disabled");
            ANNE.A.addClass(nextBtn, "disabled");
            ANNE.A.addClass(firstBtn, "disabled");
            ANNE.A.addClass(prevBtn, "disabled");
            
            for (var b=0; b < btns.length; b++) {
                if (b!=$activeIndex) btns[b].classList.remove("active");
                else btns[b].classList.add("active");
            }
        }
    }
}